`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/01/23 14:15:05
// Design Name: 
// Module Name: SPI_data_buf
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module SPI_data_buf(
    input             sysclk,
    input             SPI_RST,
    input             START,
    input             RXSIG,
    input [7:0]       INDATA02,
    output reg [7:0]  OUTDATA02,
    
    input [7:0]       INDATA45,
    input [7:0]       INDATA4e,
    
    output            TXSIG,
    output            SPICLK,
    output            SS_b,
    
    output reg [0:0]  Bypass,
    output reg [0:0]  POL,
    output reg [0:0]  STEP0,
    output reg [0:0]  STEP1,
    output reg [0:0]  CPHA,
    output reg [0:0]  CPOL,
    
    output reg   RSPI_b =1'b1,
    output reg   Reset_b =1'b1,
    
    input INDATA03,
    input INDATA04,
    input INDATA05,
    input INDATA06,
    input INDATA07,
    input INDATA08,
    input INDATA09,
    input INDATA0a,
    input INDATA0b,
    input INDATA0c,
    input INDATA0d,
    input INDATA0e,
    input INDATA0f,
    input INDATA10,
    input INDATA11,
    input INDATA12,
    input INDATA13,
    input INDATA14,
    input INDATA15,
    input INDATA16,
    input INDATA17,
    input INDATA18,
    input INDATA19,
    input INDATA1a,
    input INDATA1b,
    input INDATA1c,
    input INDATA1d,
    input INDATA1e,
    
    input INDATA4f,
    
    output  reg [7:0] OUTDATA03,
    output  reg [7:0] OUTDATA04,
    output  reg [7:0] OUTDATA05,
    output  reg [7:0] OUTDATA06,
    output  reg [7:0] OUTDATA07,
    output  reg [7:0] OUTDATA08,
    output  reg [7:0] OUTDATA09,
    output  reg [7:0] OUTDATA0a,
    output  reg [7:0] OUTDATA0b,
    output  reg [7:0] OUTDATA0c,
    output  reg [7:0] OUTDATA0d,
    output  reg [7:0] OUTDATA0e,
    output  reg [7:0] OUTDATA0f,
    output  reg [7:0] OUTDATA10,
    output  reg [7:0] OUTDATA11,
    output  reg [7:0] OUTDATA12,
    output  reg [7:0] OUTDATA13,
    output  reg [7:0] OUTDATA14,
    output  reg [7:0] OUTDATA15,
    output  reg [7:0] OUTDATA16,
    output  reg [7:0] OUTDATA17,
    output  reg [7:0] OUTDATA18,
    output  reg [7:0] OUTDATA19,
    output  reg [7:0] OUTDATA1a,
    output  reg [7:0] OUTDATA1b,
    output  reg [7:0] OUTDATA1c,
    output  reg [7:0] OUTDATA1d,
    output  reg [7:0] OUTDATA1e,
    
    output  reg [7:0] OUTDATA4f
    );
    
    reg [223:0] TXDATA = 224'h00;
    wire [223:0] RXDATA;
    
    reg [7:0] b_1;
    reg [7:0] b_2;
    reg [7:0] b_3;
    reg [7:0] b_4;
    reg [7:0] b_5;
    reg [7:0] b_6;
    reg [7:0] b_7;
    reg [7:0] b_8;
    reg [7:0] b_9;
    reg [7:0] b_10;
    reg [7:0] b_11;
    reg [7:0] b_12;
    reg [7:0] b_13;
    reg [7:0] b_14;
    reg [7:0] b_15;
    reg [7:0] b_16;
    reg [7:0] b_17;
    reg [7:0] b_18;
    reg [7:0] b_19;
    reg [7:0] b_20;
    reg [7:0] b_21;
    reg [7:0] b_22;
    reg [7:0] b_23;
    reg [7:0] b_24;
    reg [7:0] b_25;
    reg [7:0] b_26;
    reg [7:0] b_27;
    reg [7:0] b_28;
    
    reg [223:0] SELFDATA = 0;
   //SPIMMƂĒl߂
   
    
    always@(posedge sysclk)begin 
     if(INDATA02 == 8'h01) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h80;
     b_6 <= 8'h2F;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h00;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
     else if(INDATA02 == 8'h02) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h97;
     b_6 <= 8'hAF;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h00;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h94;
     b_28 <= 8'h47;
     end
     else if(INDATA02 == 8'h03) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h97;
     b_6 <= 8'hAF;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h00;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
     else if(INDATA02 == 8'h04) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h97;
     b_6 <= 8'hAF;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h00;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h97;
     b_28 <= 8'hFF;
     end
     else if(INDATA02 == 8'h05) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h97;
     b_6 <= 8'hAF;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h00;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h90;
     b_28 <= 8'h07;
     end
     else if(INDATA02 == 8'h06) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h85;
     b_6 <= 8'h2F;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h00;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
     else if(INDATA02 == 8'h07) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h8A;
     b_6 <= 8'h2F;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h00;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
     else if(INDATA02 == 8'h08) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h8F;
     b_6 <= 8'h2F;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h00;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
                             
     else if(INDATA02 == 8'h09) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h94;
     b_6 <= 8'h2F;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h00;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
     else if(INDATA02 == 8'h0a) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h80;
     b_6 <= 8'h2F;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h0C;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
     else if(INDATA02 == 8'h0b) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h80;
     b_6 <= 8'h2F;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h20;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
     else if(INDATA02 == 8'h0c) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h80;
     b_6 <= 8'h2F;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h34;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
     else if(INDATA02 == 8'h0d) begin
     b_1 <= 8'h00;//chB
     b_2 <= 8'h04;
     b_3 <= 8'hB0;
     b_4 <= 8'hBF;
     b_5 <= 8'h80;
     b_6 <= 8'h2F;
     b_7 <= 8'hFF;
     b_8 <= 8'hFF;
     b_9 <= 8'hFF;
     b_10 <= 8'hFF;
     b_11 <= 8'h00;
     b_12 <= 8'h00;
     b_13 <= 8'h48;//chA
     b_14 <= 8'h04;
     b_15 <= 8'hB0;
     b_16 <= 8'hBF;
     b_17 <= 8'h97;
     b_18 <= 8'hAF;
     b_19 <= 8'hFF;
     b_20 <= 8'hFF;
     b_21 <= 8'hFF;
     b_22 <= 8'hFF;
     b_23 <= 8'h00;
     b_24 <= 8'h00;
     b_25 <= 8'hBF;//PLL
     b_26 <= 8'h01;//Common
     b_27 <= 8'h91;
     b_28 <= 8'h17;
     end
     else if(INDATA02 == 8'hff) begin
     b_1 <= INDATA03;//chB
     b_2 <= INDATA04;
     b_3 <= INDATA05;
     b_4 <= INDATA06;
     b_5 <= INDATA07;
     b_6 <= INDATA08;
     b_7 <= INDATA09;
     b_8 <= INDATA0a;
     b_9 <= INDATA0b;
     b_10 <= INDATA0c;
     b_11 <= INDATA0d;
     b_12 <= INDATA0e;
     b_13 <= INDATA0f;//chA
     b_14 <= INDATA10;
     b_15 <= INDATA11;
     b_16 <= INDATA12;
     b_17 <= INDATA13;
     b_18 <= INDATA14;
     b_19 <= INDATA15;
     b_20 <= INDATA16;
     b_21 <= INDATA17;
     b_22 <= INDATA18;
     b_23 <= INDATA19;
     b_24 <= INDATA1a;
     b_25 <= INDATA1b;//PLL
     b_26 <= INDATA1c;//Common
     b_27 <= INDATA1d;
     b_28 <= INDATA1e;
     SELFDATA[223:0]  <= { b_1, b_2, b_3, b_4, b_5, b_6, b_7, b_8, b_9, b_10, b_11, b_12, b_13, b_14, b_15, b_16, b_17, b_18, b_19, b_20, b_21, b_22, b_23, b_24, b_25, b_26, b_27, b_28 };
     end
    end
    always@(posedge sysclk)begin
     TXDATA[223:0]  <= { b_1, b_2, b_3, b_4, b_5, b_6, b_7, b_8, b_9, b_10, b_11, b_12, b_13, b_14, b_15, b_16, b_17, b_18, b_19, b_20, b_21, b_22, b_23, b_24, b_25, b_26, b_27, b_28 };     
    end
    
    always@(posedge sysclk)begin   
          if(INDATA4e == 8'h03) begin
          RSPI_b =1'b0;
          Reset_b =1'b0;
          end
          else if(INDATA4f == 8'h03) begin
          Reset_b =1'b0;
          end
          else begin
          RSPI_b =1'b1;
          Reset_b =1'b1;
          end
    end
    
    always@(posedge sysclk)begin
    if(INDATA4e == 8'h03) begin
     Bypass <= 1'b0; 
     POL <= 1'b0;   
     STEP0 <= 1'b0;
     STEP1 <= 1'b0;
     CPHA <= 1'b0;
     CPOL <= 1'b0;
     end
     else if(INDATA45 == 8'h00) begin
     Bypass <= 1'b0; 
     POL <= 1'b0;   
     STEP0 <= 1'b0;//STEP28
     STEP1 <= 1'b1;
     CPHA <= 1'b0;
     CPOL <= 1'b0;
     end
     else if(INDATA45 == 8'h01) begin
     Bypass <= 1'b0; 
     POL <= 1'b0;   
     STEP0 <= 1'b0;//STEP20
     STEP1 <= 1'b0;
     CPHA <= 1'b0;
     CPOL <= 1'b0;
     end
     else if(INDATA45 == 8'h02) begin
     Bypass <= 1'b0; 
     POL <= 1'b0;   
     STEP0 <= 1'b1;//STEP24
     STEP1 <= 1'b0;
     CPHA <= 1'b0;
     CPOL <= 1'b0;
     end
     else if(INDATA45 == 8'h03) begin
     Bypass <= 1'b0; 
     POL <= 1'b0;   
     STEP0 <= 1'b1;//STEP32
     STEP1 <= 1'b1;
     CPHA <= 1'b0;
     CPOL <= 1'b0;
     end
    end
    
    always@(posedge sysclk)begin
     if      (RXDATA == 224'h0004B0BF802FFFFFFFFF00000004B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h01;
     else if (RXDATA == 224'h0004B0BF97AFFFFFFFFF00000004B0BF97AFFFFFFFFF0000BF019447) OUTDATA02 <= 8'h02;
     else if (RXDATA == 224'h0004B0BF97AFFFFFFFFF00000004B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h03;
     else if (RXDATA == 224'h0004B0BF97AFFFFFFFFF00000004B0BF97AFFFFFFFFF0000BF0197FF) OUTDATA02 <= 8'h04;
     else if (RXDATA == 224'h0004B0BF97AFFFFFFFFF00000004B0BF97AFFFFFFFFF0000BF019007) OUTDATA02 <= 8'h05;
     else if (RXDATA == 224'h0004B0BF852FFFFFFFFF00000004B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h06;
     else if (RXDATA == 224'h0004B0BF8A2FFFFFFFFF00000004B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h07;
     else if (RXDATA == 224'h0004B0BF8F2FFFFFFFFF00000004B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h08;
     else if (RXDATA == 224'h0004B0BF942FFFFFFFFF00000004B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h09;
     else if (RXDATA == 224'h0004B0BF802FFFFFFFFF00000C04B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h0a;
     else if (RXDATA == 224'h0004B0BF802FFFFFFFFF00002004B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h0b;
     else if (RXDATA == 224'h0004B0BF802FFFFFFFFF00003404B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h0c;
     else if (RXDATA == 224'h0004B0BF802FFFFFFFFF00004804B0BF97AFFFFFFFFF0000BF019117) OUTDATA02 <= 8'h0d;
     else if (RXDATA == SELFDATA) OUTDATA02 <= 8'hff;
     else OUTDATA02 <= 8'h00;
    end
    
    always@(posedge sysclk)begin
     OUTDATA03 <= RXDATA[223:216];
     OUTDATA04 <= RXDATA[215:208];
     OUTDATA05 <= RXDATA[207:200];
     OUTDATA06 <= RXDATA[199:192];
     OUTDATA07 <= RXDATA[191:184];
     OUTDATA08 <= RXDATA[183:176];
     OUTDATA09 <= RXDATA[175:168];
     OUTDATA0a <= RXDATA[167:160];
     OUTDATA0b <= RXDATA[159:152];
     OUTDATA0c <= RXDATA[151:144];
     OUTDATA0d <= RXDATA[143:136];
     OUTDATA0e <= RXDATA[135:128];
     OUTDATA0f <= RXDATA[127:120];
     OUTDATA10 <= RXDATA[119:112];
     OUTDATA11 <= RXDATA[111:104];
     OUTDATA12 <= RXDATA[103:96];
     OUTDATA13 <= RXDATA[95:88];
     OUTDATA14 <= RXDATA[87:80];
     OUTDATA15 <= RXDATA[79:72];
     OUTDATA16 <= RXDATA[71:64];
     OUTDATA17 <= RXDATA[63:56];
     OUTDATA18 <= RXDATA[55:48];
     OUTDATA19 <= RXDATA[47:40];
     OUTDATA1a <= RXDATA[39:32];
     OUTDATA1b <= RXDATA[31:24];
     OUTDATA1c <= RXDATA[23:16];
     OUTDATA1d <= RXDATA[15:8];
     OUTDATA1e <= RXDATA[7:0];
    end
    
    
    SPI SPI(
         .CLK    (sysclk),
         .RST    (SPI_RST),
         .START  (START),
         .TXDATA (TXDATA),
         .RXSIG  (RXSIG),
         .TXSIG  (TXSIG),
         .RXDATA (RXDATA),
         .SPICLK (SPICLK),
         .SS_b   (SS_b ),
         .INDATA4e (INDATA4e)
         );
         
endmodule
