`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/12/20 13:31:35
// Design Name: 
// Module Name: Top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Top(
  input wire CLKIN,
  input wire EEPROM_DO,
  output wire EEPROM_CS,
  output wire EEPROM_SK,
  output wire EEPROM_DI,
  output wire ETH_CLKIN,
  output wire GTX_CLK, 
  output wire GMII_TX_EN,
  output wire GMII_TX_ER, 
  output wire MDC, 
  input wire GMII_1000M, 
  output wire GMII_RSTn,
  input wire RX_CLK, TX_CLK,
  input wire RX_DV,
  input wire RX_ER,
  input wire RX_CRS,
  input wire RX_COL,
  inout wire MDIO,
  input wire [7:0] RX_D,
  output wire [7:0] GMII_TXD,
  
  input wire RST_BUT,
  output wire LED0,
  output wire LED1,
  output wire LED5,
  output wire MOSI_EX,
  output wire SCK_EX,
  output wire SS_EX,
  
  //for_PP_ASIC
  output        PP_CLK,
  output        RSPI_b,
  output        Reset_b,
  //input wire SPI
  input         MISO,
  output        MOSI,
  output        SPICLK,
  output        SS_b,
  
  output Bypass,
  output POL,
  output STEP0,
  output STEP1,
  output CPHA,
  output CPOL,
  
  //ADC
  input Vconp,
  input Vconn,
  input TPAp,
  input TPAn,
  input TPAbp,
  input TPAbn,
  input TPBp,
  input TPBn,
  input TPBbp,
  input TPBbn,
  input PP18p,
  input PP18n,
  input PP33p,
  input PP33n,
  input vp_in,
  input vn_in,
  
  
  //PP_ASIC_ports
  output Ach0p,
  output Ach0n,
  output Ach1p,
  output Ach1n,
  output Ach2p,
  output Ach2n,
  output Ach3p,
  output Ach3n,
  output Ach4p,
  output Ach4n,
  output Ach5p,
  output Ach5n,
  output Ach6p,
  output Ach6n,
  output Ach7p,
  output Ach7n,
  output Ach8p,
  output Ach8n,
  output Ach9p,
  output Ach9n,
  output Ach10p,
  output Ach10n,
  output Ach11p,
  output Ach11n,
  output Ach12p,
  output Ach12n,
  output Ach13p,
  output Ach13n,
  output Ach14p,
  output Ach14n,
  output Ach15p,
  output Ach15n,
  
  output Bch0p,
  output Bch0n,
  output Bch1p,
  output Bch1n,
  output Bch2p,
  output Bch2n,
  output Bch3p,
  output Bch3n,
  output Bch4p,
  output Bch4n,
  output Bch5p,
  output Bch5n,
  output Bch6p,
  output Bch6n,
  output Bch7p,
  output Bch7n,
  output Bch8p,
  output Bch8n,
  output Bch9p,
  output Bch9n,
  output Bch10p,
  output Bch10n,
  output Bch11p,
  output Bch11n,
  output Bch12p,
  output Bch12n,
  output Bch13p,
  output Bch13n,
  output Bch14p,
  output Bch14n,
  output Bch15p,
  output Bch15n,
      
  input Ach0,
  input Ach1,
  input Ach2,
  input Ach3,
  input Ach4,
  input Ach5,
  input Ach6,
  input Ach7,
  input Ach8,
  input Ach9,
  input Ach10,
  input Ach11,
  input Ach12,
  input Ach13,
  input Ach14,
  input Ach15,
  input Bch0,
  input Bch1,
  input Bch2,
  input Bch3,
  input Bch4,
  input Bch5,
  input Bch6,
  input Bch7,
  input Bch8,
  input Bch9,
  input Bch10,
  input Bch11,
  input Bch12,
  input Bch13,
  input Bch14,
  input Bch15,
    
  //for_test_pulse
  output TPTRIG,
  output TPTC,
  
  //output reg START,
  
  //for_delay
  input   delout,
  output delin,
  
  //for PPASICPG
  output PP33EN,
  output PP18EN,
  output PP33ENb,
  output PP18ENb
  );
  
  wire sysclk;
  IBUF    clk_ibuf(.O(sysclk),.I(CLKIN));
  //assign PP_CLK = sysclk; 
  
  assign TPTC = TPTRIG;
  
  //assign LED0 = sysclk;
  wire CLK125;
  wire CLK25;
  wire CLK_Si;
  wire CLK40adc;
  //IBUF    clk_ibuf(.O(CLK200),.I(CLKIN));
  wire reset = 1'b0;
  wire locked;
  
  //assign MOSI_EX = CLK_Si;
  //assign SCK_EX = sysclk;
  //assign SS_EX = RST_BUT;

    clk_wiz_0 PHYCLK
    (
    // Clock in ports
    .clk_in1(sysclk),    // input clk_in1_p
    // Clock out ports
    .clk_out1(CLK125),     // output clk_out1
    .clk_out2(CLK25 ),     // output clk_out2
    .clk_out3(CLK_Si),   //129ȏAclock͂낦ق
    .clk_out4(CLK40adc ),
    // Status and control signals
    .reset(reset), // input reset
    .locked(locked));      // output locked
  
  wire CLK200s;
  wire CLK40s;
  wire CLK8;
  wire CLK200_2;
      
  wire resets = 1'b0;
  wire lockeds;
     
      
    clk_wiz_1 sigclk 
    (
    // Clock in ports
    .clk_in1(sysclk),    // input clk_in1
    // Clock out ports
    .clk_out1(CLK200s),     // output clk_out1
    .clk_out2(CLK40s ),     // output clk_out2
    .clk_out3(CLK8),     // output clk_out3
    .clk_out4(CLK200_2),     // output clk_out3
    // Status and control signals
    .reset(resets), // input reset
    .locked(lockeds));      // output locked
      
      
      


  wire GMII_MDIO_OE, GMII_MDIO_OUT, GMII_TX_CLK;
  assign MDIO = (GMII_MDIO_OE ? GMII_MDIO_OUT : 1'bz);
  assign GMII_TX_CLK = (~GMII_1000M ? CLK125 : TX_CLK);
  assign GTX_CLK = CLK125;
  assign ETH_CLKIN = CLK25;

  wire [31:0] ADDRIN,ADDROUT;
  reg RBCP_ACK = 1'b1;
  //reg RBCP_ACKW;
  //reg RBCP_ACKR;
  reg RST = 1'b0;
  //reg RBCP_ACK;
  wire [31:0] RBCP_ADDR;
  reg [7:0] RBCP_RD;
  wire [7:0] RBCP_WD;
  wire RBCP_RE;
  wire RBCP_ACT;
  wire RBCP_WE;
  WRAP_SiTCP_GMII_XC7A_32K SiTCP(
      .CLK(CLK_Si),
      .RST(RST),
  // Configuration parameters
      .FORCE_DEFAULTn (1'b0       ),
      .EXT_IP_ADDR    (32'h0      ),
      .EXT_TCP_PORT   (16'd0      ),
      .EXT_RBCP_PORT  (16'd0      ),
      .PHY_ADDR       (5'b00001   ),
      // EEPROM
      .EEPROM_CS                (EEPROM_CS                ),    // out    : Chip select
      .EEPROM_SK                (EEPROM_SK                ),    // out    : Serial data clock
      .EEPROM_DI                (EEPROM_DI                ),    // out    : Serial write data
      .EEPROM_DO                (EEPROM_DO                ),    // in    : Serial read data
  // MII interface
      .GMII_1000M               (1'b1              ),    // in    : GMII mode (0:MII, 1:GMII)
      //.GMII_1000M               (~GMII_1000M              ),    // in    : GMII mode (0:MII, 1:GMII)
      .GMII_RSTn                (GMII_RSTn                ),    // in    : PHY reset
      // TX
      .GMII_TX_CLK              (GMII_TX_CLK              ),    // in    : Tx clock(2.5 or 25MHz)
      .GMII_TX_EN               (GMII_TX_EN               ),    // out    : Tx enable
      .GMII_TXD                 (GMII_TXD[7:0]            ),    // out    : Tx data[7:0]
      .GMII_TX_ER               (GMII_TX_ER               ),    // out    : TX error
      // RX
      .GMII_RX_CLK              (RX_CLK                   ),    // in    : Rx clock(2.5 or 25MHz)
      .GMII_RX_DV               (RX_DV                    ),    // in    : Rx data valid
      .GMII_RXD                 (RX_D[7:0]                ),    // in    : Rx data[7:0]
      .GMII_RX_ER               (RX_ER                    ),    // in    : Rx error
      .GMII_CRS                 (RX_CRS                   ),    // in    : Carrier sense
      .GMII_COL                 (RX_COL                   ),    // in    : Collision detected
      // Management IF
      .GMII_MDC                 (MDC                      ),    // out    : Clock for MDIO
      .GMII_MDIO_IN             (MDIO                     ),    // in    : Data
      .GMII_MDIO_OUT            (GMII_MDIO_OUT            ),    // out    : Data
      .GMII_MDIO_OE             (GMII_MDIO_OE             ),    // out    : MDIO output enable
      // RBCP
      .RBCP_ACT                 (RBCP_ACT                 ),    // out    : RBCP active
      .RBCP_ADDR                (RBCP_ADDR[31:0]          ),    // out    : Address[31:0]
      .RBCP_WD                  (RBCP_WD[7:0]             ),    // out    : Data[7:0]
      .RBCP_WE                  (RBCP_WE                  ),    // out    : Write enable
      .RBCP_RE                  (RBCP_RE                  ),    // out    : Read enable
      .RBCP_ACK                 (RBCP_ACK                 ),    // in    : Access acknowledge
      .RBCP_RD                  (RBCP_RD[7:0]             )    // in    : Read data[7:0]
  );
  
  
  

  
  //Data buffer
  reg [7:0] INDATA00 = 8'h00;
  reg [7:0] OUTDATA00;
  reg [7:0] INDATA01 = 8'h03;
  reg [7:0] OUTDATA01;
  reg [7:0] INDATA02;
  wire [7:0] OUTDATA02;
  reg [7:0] INDATA03 = 8'h00;
  wire [7:0] OUTDATA03;
  reg [7:0] INDATA04 = 8'h01;
  wire [7:0] OUTDATA04;
  reg [7:0] INDATA05 = 8'h90;
  wire [7:0] OUTDATA05;
  reg [7:0] INDATA06 = 8'hBF;
  wire [7:0] OUTDATA06;
  reg [7:0] INDATA07 = 8'h80;
  wire [7:0] OUTDATA07;
  reg [7:0] INDATA08 = 8'h2F;
  wire [7:0] OUTDATA08;
  reg [7:0] INDATA09 = 8'hFF;
  wire [7:0] OUTDATA09;
  reg [7:0] INDATA0a = 8'hFF;
  wire [7:0] OUTDATA0a;
  reg [7:0] INDATA0b = 8'hFF;
  wire [7:0] OUTDATA0b;
  reg [7:0] INDATA0c = 8'hFF;
  wire [7:0] OUTDATA0c;
  reg [7:0] INDATA0d = 8'h00;
  wire [7:0] OUTDATA0d;
  reg [7:0] INDATA0e = 8'h00;
  wire [7:0] OUTDATA0e;
  reg [7:0] INDATA0f = 8'h00;
  wire [7:0] OUTDATA0f;
  reg [7:0] INDATA10 = 8'h01;
  wire [7:0] OUTDATA10;
  reg [7:0] INDATA11 = 8'h90;
  wire [7:0] OUTDATA11;
  reg [7:0] INDATA12 = 8'hBF;
  wire [7:0] OUTDATA12;
  reg [7:0] INDATA13 = 8'h80;
  wire [7:0] OUTDATA13;
  reg [7:0] INDATA14 = 8'h2F;
  wire [7:0] OUTDATA14;
  reg [7:0] INDATA15 = 8'hFF;
  wire [7:0] OUTDATA15;
  reg [7:0] INDATA16 = 8'hFF;
  wire [7:0] OUTDATA16;
  reg [7:0] INDATA17 = 8'hFF;
  wire [7:0] OUTDATA17;
  reg [7:0] INDATA18 = 8'hFF;
  wire [7:0] OUTDATA18;
  reg [7:0] INDATA19 = 8'h00;
  wire [7:0] OUTDATA19;
  reg [7:0] INDATA1a = 8'h00;
  wire [7:0] OUTDATA1a;
  reg [7:0] INDATA1b = 8'hBF;
  wire [7:0] OUTDATA1b;
  reg [7:0] INDATA1c = 8'h01;
  wire [7:0] OUTDATA1c;
  reg [7:0] INDATA1d = 8'h94;
  wire [7:0] OUTDATA1d;
  reg [7:0] INDATA1e = 8'h47;
  wire [7:0] OUTDATA1e;
  reg [7:0] INDATA1f = 8'h00;
  wire [7:0] OUTDATA1f;
  reg [7:0] INDATA20 = 8'h03;
  wire [7:0] OUTDATA20;
  reg [7:0] INDATA21;
  wire [7:0] OUTDATA21;
  reg [7:0] INDATA22;
  wire [7:0] OUTDATA22;
  reg [7:0] INDATA23 = 8'h00;
  wire [7:0] OUTDATA23;
  reg [7:0] INDATA24;
  wire [7:0] OUTDATA24;
  reg [7:0] INDATA25 = 8'h00;
  wire [7:0] OUTDATA25;
  reg [7:0] INDATA26 = 8'h00;
  wire [7:0] OUTDATA26;    
  reg [7:0] INDATA27 = 8'h03;
  wire [7:0] OUTDATA27;
  reg [7:0] INDATA28;
  wire [7:0] OUTDATA28;
  reg [7:0] INDATA29;
  wire [7:0] OUTDATA29;
  reg [7:0] INDATA2a;
  wire [7:0] OUTDATA2a;
  reg [7:0] INDATA2b;
  wire [7:0] OUTDATA2b;
  reg [7:0] INDATA2c;
  wire [7:0] OUTDATA2c;
  reg [7:0] INDATA2d;
  wire [7:0] OUTDATA2d;
  reg [7:0] INDATA2e;
  wire [7:0] OUTDATA2e;
  reg [7:0] INDATA2f;
  wire [7:0] OUTDATA2f;
  reg [7:0] INDATA30;
  wire [7:0] OUTDATA30;
  reg [7:0] INDATA31;
  wire [7:0] OUTDATA31;
  reg [7:0] INDATA32;
  wire [7:0] OUTDATA32;
  reg [7:0] INDATA33;
  wire [7:0] OUTDATA33;
  reg [7:0] INDATA34;
  wire [7:0] OUTDATA34;
  reg [7:0] INDATA35;
  wire [7:0] OUTDATA35;
  reg [7:0] INDATA36;
  wire [7:0] OUTDATA36;    
  reg [7:0] INDATA37;
  wire [7:0] OUTDATA37;
  reg [7:0] INDATA38;
  wire [7:0] OUTDATA38;
  reg [7:0] INDATA39;
  wire [7:0] OUTDATA39;
  reg [7:0] INDATA3a;
  wire [7:0] OUTDATA3a;
  reg [7:0] INDATA3b;
  wire [7:0] OUTDATA3b;
  reg [7:0] INDATA3c;
  wire [7:0] OUTDATA3c;
  reg [7:0] INDATA3d;
  wire [7:0] OUTDATA3d;
  reg [7:0] INDATA3e;
  wire [7:0] OUTDATA3e;
  reg [7:0] INDATA3f;
  wire [7:0] OUTDATA3f;
  reg [7:0] INDATA40;
  wire [7:0] OUTDATA40;
  reg [7:0] INDATA41;
  wire [7:0] OUTDATA41;
  reg [7:0] INDATA42 = 8'h00;
  wire [7:0] OUTDATA42;
  reg [7:0] INDATA43 = 8'h03;
  wire [7:0] OUTDATA43;
  reg [7:0] INDATA44;
  wire [7:0] OUTDATA44;
  reg [7:0] INDATA45 = 8'h00;
  wire [7:0] OUTDATA45;
  reg [7:0] INDATA46 = 8'h00;
  wire [7:0] OUTDATA46;
  reg [7:0] INDATA47 = 8'h03;
  wire [7:0] OUTDATA47;
  reg [7:0] INDATA48 = 8'h03;
  wire [7:0] OUTDATA48;
  reg [7:0] INDATA49;
  wire [7:0] OUTDATA49;
  reg [7:0] INDATA4a = 8'h00;
  wire [7:0] OUTDATA4a;
  reg [7:0] INDATA4b = 8'h00;
  wire [7:0] OUTDATA4b;
  reg [7:0] INDATA4c = 8'h00;
  wire [7:0] OUTDATA4c;
  reg [7:0] INDATA4d = 8'h03;
  wire [7:0] OUTDATA4d;
  reg [7:0] INDATA4e = 8'h03;
  wire [7:0] OUTDATA4e;
  reg [7:0] INDATA4f = 8'h00;
  wire [7:0] OUTDATA4f;
    
  
  always@(posedge CLK_Si)begin
  if(RBCP_ADDR == 32'h00)begin
   if(RBCP_WE) INDATA00[7:0] <= RBCP_WD[7:0];//gK[M
   else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA00[7:0];
  end
  else if(RBCP_ADDR == 32'h01)begin
   if(RBCP_WE) INDATA01[7:0] <= RBCP_WD[7:0];
   else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA01[7:0];
  end
  else if(RBCP_ADDR == 32'h02)begin
   if(RBCP_WE) INDATA02[7:0] <= RBCP_WD[7:0];
   else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA02[7:0];//}ʂv邩o
  end
  else if(RBCP_ADDR == 32'h03)begin
     if(RBCP_WE) INDATA03[7:0] <= RBCP_WD[7:0];
     else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA03[7:0];
  end
  else if(RBCP_ADDR == 32'h04)begin
      if(RBCP_WE) INDATA04[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA04[7:0];
  end
  else if(RBCP_ADDR == 32'h05)begin
      if(RBCP_WE) INDATA05[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA05[7:0];
  end
  else if(RBCP_ADDR == 32'h06)begin
      if(RBCP_WE) INDATA06[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA06[7:0];
  end
  else if(RBCP_ADDR == 32'h07)begin
      if(RBCP_WE) INDATA07[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA07[7:0];
  end
  else if(RBCP_ADDR == 32'h08)begin
      if(RBCP_WE) INDATA08[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA08[7:0];
  end
  else if(RBCP_ADDR == 32'h09)begin
      if(RBCP_WE) INDATA09[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA09[7:0];
  end
  else if(RBCP_ADDR == 32'h0a)begin
      if(RBCP_WE) INDATA0a[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA0a[7:0];
  end
  else if(RBCP_ADDR == 32'h0b)begin
      if(RBCP_WE) INDATA0b[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA0b[7:0];
  end
  else if(RBCP_ADDR == 32'h0c)begin
      if(RBCP_WE) INDATA0c[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA0c[7:0];
  end
  else if(RBCP_ADDR == 32'h0d)begin
      if(RBCP_WE) INDATA0d[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA0d[7:0];
  end
  else if(RBCP_ADDR == 32'h0e)begin
      if(RBCP_WE) INDATA0e[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA0e[7:0];
  end
  else if(RBCP_ADDR == 32'h0f)begin
      if(RBCP_WE) INDATA0f[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA0f[7:0];
  end
  else if(RBCP_ADDR == 32'h10)begin
      if(RBCP_WE) INDATA10[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA10[7:0];
  end
  else if(RBCP_ADDR == 32'h11)begin
      if(RBCP_WE) INDATA11[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA11[7:0];
  end
  else if(RBCP_ADDR == 32'h12)begin
      if(RBCP_WE) INDATA12[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA12[7:0];
  end
  else if(RBCP_ADDR == 32'h13)begin
      if(RBCP_WE) INDATA13[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA13[7:0];
  end
  else if(RBCP_ADDR == 32'h14)begin
      if(RBCP_WE) INDATA14[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA14[7:0];
  end
  else if(RBCP_ADDR == 32'h15)begin
      if(RBCP_WE) INDATA15[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA15[7:0];
  end
  else if(RBCP_ADDR == 32'h16)begin
      if(RBCP_WE) INDATA16[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA16[7:0];
  end
  else if(RBCP_ADDR == 32'h17)begin
      if(RBCP_WE) INDATA17[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA17[7:0];
  end
  else if(RBCP_ADDR == 32'h18)begin
      if(RBCP_WE) INDATA18[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA18[7:0];
  end
  else if(RBCP_ADDR == 32'h19)begin
      if(RBCP_WE) INDATA19[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA19[7:0];
  end
  else if(RBCP_ADDR == 32'h1a)begin
      if(RBCP_WE) INDATA1a[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA1a[7:0];
  end
  else if(RBCP_ADDR == 32'h1b)begin
      if(RBCP_WE) INDATA1b[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA1b[7:0];
  end
  else if(RBCP_ADDR == 32'h1c)begin
      if(RBCP_WE) INDATA1c[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA1c[7:0];
  end
  else if(RBCP_ADDR == 32'h1d)begin
      if(RBCP_WE) INDATA1d[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA1d[7:0];
  end
  else if(RBCP_ADDR == 32'h1e)begin
      if(RBCP_WE) INDATA1e[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA1e[7:0];
  end
  else if(RBCP_ADDR == 32'h1f)begin
      if(RBCP_WE) INDATA1f[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA1f[7:0];
  end
  else if(RBCP_ADDR == 32'h20)begin
      if(RBCP_WE) INDATA20[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA20[7:0];
  end
  else if(RBCP_ADDR == 32'h21)begin
      if(RBCP_WE) INDATA21[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA21[7:0];
  end
  else if(RBCP_ADDR == 32'h22)begin
      if(RBCP_WE) INDATA22[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA22[7:0];
  end
  else if(RBCP_ADDR == 32'h23)begin
      if(RBCP_WE) INDATA23[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA23[7:0];
  end
  else if(RBCP_ADDR == 32'h24)begin
      if(RBCP_WE) INDATA24[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA24[7:0];
  end
  else if(RBCP_ADDR == 32'h25)begin
      if(RBCP_WE) INDATA25[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA25[7:0];
  end
  else if(RBCP_ADDR == 32'h26)begin
      if(RBCP_WE) INDATA26[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA26[7:0];
  end
  else if(RBCP_ADDR == 32'h27)begin
      if(RBCP_WE) INDATA27[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA27[7:0];
  end
  else if(RBCP_ADDR == 32'h28)begin
      if(RBCP_WE) INDATA28[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA28[7:0];
  end
  else if(RBCP_ADDR == 32'h29)begin
      if(RBCP_WE) INDATA29[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA29[7:0];
  end
  else if(RBCP_ADDR == 32'h2a)begin
      if(RBCP_WE) INDATA2a[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA2a[7:0];
  end
  else if(RBCP_ADDR == 32'h2b)begin
      if(RBCP_WE) INDATA2b[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA2b[7:0];
  end
  else if(RBCP_ADDR == 32'h2c)begin
      if(RBCP_WE) INDATA2c[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA2c[7:0];
  end
  else if(RBCP_ADDR == 32'h2d)begin
      if(RBCP_WE) INDATA2d[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA2d[7:0];
  end
  else if(RBCP_ADDR == 32'h2e)begin
      if(RBCP_WE) INDATA2e[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA2e[7:0];
  end
  else if(RBCP_ADDR == 32'h2f)begin
      if(RBCP_WE) INDATA2f[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA2f[7:0];
  end
  else if(RBCP_ADDR == 32'h30)begin
      if(RBCP_WE) INDATA30[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA30[7:0];
  end
  else if(RBCP_ADDR == 32'h31)begin
      if(RBCP_WE) INDATA31[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA31[7:0];
  end
  else if(RBCP_ADDR == 32'h32)begin
      if(RBCP_WE) INDATA32[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA32[7:0];
  end
  else if(RBCP_ADDR == 32'h33)begin
      if(RBCP_WE) INDATA33[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA33[7:0];
  end
  else if(RBCP_ADDR == 32'h34)begin
      if(RBCP_WE) INDATA34[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA34[7:0];
  end
  else if(RBCP_ADDR == 32'h35)begin
      if(RBCP_WE) INDATA35[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA35[7:0];
  end
  else if(RBCP_ADDR == 32'h36)begin
      if(RBCP_WE) INDATA36[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA36[7:0];
  end
  else if(RBCP_ADDR == 32'h37)begin
      if(RBCP_WE) INDATA37[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA37[7:0];
  end
  else if(RBCP_ADDR == 32'h38)begin
      if(RBCP_WE) INDATA38[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA38[7:0];
  end
  else if(RBCP_ADDR == 32'h39)begin
      if(RBCP_WE) INDATA39[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA39[7:0];
  end
  else if(RBCP_ADDR == 32'h3a)begin
      if(RBCP_WE) INDATA3a[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA3a[7:0];
  end
  else if(RBCP_ADDR == 32'h3b)begin
      if(RBCP_WE) INDATA3b[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA3b[7:0];
  end
  else if(RBCP_ADDR == 32'h3c)begin
      if(RBCP_WE) INDATA3c[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA3c[7:0];
  end
  else if(RBCP_ADDR == 32'h3d)begin
      if(RBCP_WE) INDATA3d[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA3d[7:0];
  end
  else if(RBCP_ADDR == 32'h3e)begin
      if(RBCP_WE) INDATA3e[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA3e[7:0];
  end
  else if(RBCP_ADDR == 32'h3f)begin
      if(RBCP_WE) INDATA3f[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA3f[7:0];
  end
  else if(RBCP_ADDR == 32'h40)begin
      if(RBCP_WE) INDATA40[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA40[7:0];
  end
  else if(RBCP_ADDR == 32'h41)begin
      if(RBCP_WE) INDATA41[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA41[7:0];
  end
  else if(RBCP_ADDR == 32'h42)begin
      if(RBCP_WE) INDATA42[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA42[7:0];
  end
  else if(RBCP_ADDR == 32'h43)begin
      if(RBCP_WE) INDATA43[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA43[7:0];
  end
  else if(RBCP_ADDR == 32'h44)begin
      if(RBCP_WE) INDATA44[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA44[7:0];
      end
  else if(RBCP_ADDR == 32'h45)begin
      if(RBCP_WE) INDATA45[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= INDATA45[7:0];//ςĂ
  end
  else if(RBCP_ADDR == 32'h46)begin
      if(RBCP_WE) INDATA46[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA46[7:0];
  end
  else if(RBCP_ADDR == 32'h47)begin
      if(RBCP_WE) INDATA47[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA47[7:0];
  end
  else if(RBCP_ADDR == 32'h48)begin
      if(RBCP_WE) INDATA48[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA48[7:0];
  end
  else if(RBCP_ADDR == 32'h49)begin
      if(RBCP_WE) INDATA49[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA49[7:0];
  end
  else if(RBCP_ADDR == 32'h4a)begin
      if(RBCP_WE) INDATA4a[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA4a[7:0];
  end
  else if(RBCP_ADDR == 32'h4b)begin
      if(RBCP_WE) INDATA4b[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA4b[7:0];
  end
  else if(RBCP_ADDR == 32'h4c)begin
      if(RBCP_WE) INDATA4c[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA4c[7:0];
  end
  else if(RBCP_ADDR == 32'h4d)begin
      if(RBCP_WE) INDATA4d[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA4d[7:0];
  end
  else if(RBCP_ADDR == 32'h4e)begin
      if(RBCP_WE) INDATA4e[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA4e[7:0];
  end
  else if(RBCP_ADDR == 32'h4f)begin
      if(RBCP_WE) INDATA4f[7:0] <= RBCP_WD[7:0];
      else if(RBCP_RE) RBCP_RD[7:0] <= OUTDATA4f[7:0];
  end
  
    RBCP_ACK  <= RBCP_RE | RBCP_WE;
   end
   
   
   reg       SPI_RST = 1'b0;
   reg       START;
   
    SPI_data_buf SPI_d_b(
       .sysclk    (sysclk),
       .SPI_RST    (SPI_RST),
       .START  (START),
       .INDATA02 (INDATA02),
       .INDATA45 (INDATA45),
       .INDATA4e (INDATA4e),
       .RXSIG  (MISO),
       .TXSIG  (MOSI),
       
       .INDATA03 (INDATA03),
       .INDATA04 (INDATA04),
       .INDATA05 (INDATA05),
       .INDATA06 (INDATA06),
       .INDATA07 (INDATA07),
       .INDATA08 (INDATA08),
       .INDATA09 (INDATA09),
       .INDATA0a (INDATA0a),
       .INDATA0b (INDATA0b),
       .INDATA0c (INDATA0c),
       .INDATA0d (INDATA0d),
       .INDATA0e (INDATA0e),
       .INDATA0f (INDATA0f),
       .INDATA10 (INDATA10),
       .INDATA11 (INDATA11),
       .INDATA12 (INDATA12),
       .INDATA13 (INDATA13),
       .INDATA14 (INDATA14),
       .INDATA15 (INDATA15),
       .INDATA16 (INDATA16),
       .INDATA17 (INDATA17),
       .INDATA18 (INDATA18),
       .INDATA19 (INDATA19),
       .INDATA1a (INDATA1a),
       .INDATA1b (INDATA1b),
       .INDATA1c (INDATA1c),
       .INDATA1d (INDATA1d),
       .INDATA1e (INDATA1e),
       
       .INDATA4f (INDATA4f),
       
       .OUTDATA02 (OUTDATA02),
       .OUTDATA03 (OUTDATA03),
       .OUTDATA04 (OUTDATA04),
       .OUTDATA05 (OUTDATA05),
       .OUTDATA06 (OUTDATA06),
       .OUTDATA07 (OUTDATA07),
       .OUTDATA08 (OUTDATA08),
       .OUTDATA09 (OUTDATA09),
       .OUTDATA0a (OUTDATA0a),
       .OUTDATA0b (OUTDATA0b),
       .OUTDATA0c (OUTDATA0c),
       .OUTDATA0d (OUTDATA0d),
       .OUTDATA0e (OUTDATA0e),
       .OUTDATA0f (OUTDATA0f),
       .OUTDATA10 (OUTDATA10),
       .OUTDATA11 (OUTDATA11),
       .OUTDATA12 (OUTDATA12),
       .OUTDATA13 (OUTDATA13),
       .OUTDATA14 (OUTDATA14),
       .OUTDATA15 (OUTDATA15),
       .OUTDATA16 (OUTDATA16),
       .OUTDATA17 (OUTDATA17),
       .OUTDATA18 (OUTDATA18),
       .OUTDATA19 (OUTDATA19),
       .OUTDATA1a (OUTDATA1a),
       .OUTDATA1b (OUTDATA1b),
       .OUTDATA1c (OUTDATA1c),
       .OUTDATA1d (OUTDATA1d),
       .OUTDATA1e (OUTDATA1e),
       
       .OUTDATA4f (OUTDATA4f),
       
       .SPICLK (SPICLK),
       .SS_b   (SS_b ),
       .Bypass  (Bypass),
       .POL     (POL),
       .STEP0   (STEP0),
       .STEP1   (STEP1),
       .CPHA    (CPHA),
       .CPOL    (CPOL),
       .RSPI_b (RSPI_b),
       .Reset_b (Reset_b)
       );
   
   
   //for_start_one_shot_SiTCP
      reg [31:0] s_cont = 32'h00000000;
      always@(posedge sysclk)begin
      if(INDATA01[7:0] == 8'h03) begin
        s_cont <= 32'h0;
        START <= 1'b0;
        //LED5 <= 1'b0;
      end
     
      else if(INDATA00[7:0] == 8'h03) begin
       if(START == 0 & s_cont == 32'h00000000) begin
        START <= 1;
        //LED5 <= 1'b1;
       end
       else if(START == 1 & s_cont == 32'h00000000) begin 
        START <= 1;
        s_cont <= 32'h00000001;
        //LED5 <= 1'b1;
       end
       else if(START == 1 & s_cont == 32'h00000001) begin 
        START <= 0;
        s_cont <= s_cont + 32'h1;
        //LED5 <= 1'b1;
       end
       else if (s_cont == 32'h00000100/*l̗]n*/ ) begin
        //LED5 <= 1'b0;
        s_cont <= s_cont;
       end
       else s_cont <= s_cont + 32'h1;
      end
      else begin
        s_cont <= 32'h0;
        START <= 1'b0;
        //LED5 <= 1'b0;
      end
     
     end
   
   
    ADC ADCandTP(
    .dclk_in (CLK200_2),             // Clock input for the dynamic reconfiguration port
    .CLK40(CLK40adc),
    
    .Vconp(Vconp),              // Auxiliary channel 0
    .Vconn(Vconn),
    .TPAp(TPAp),              // Auxiliary channel 2
    .TPAn(TPAn),
    .TPBbp(TPBbp),
    .TPBbn(TPBbn),
    .PP18p(PP18p), 
    .PP18n(PP18n),
    .PP33p(PP33p), 
    .PP33n(PP33n),
    .TPAbp(TPAbp), 
    .TPAbn(TPAbn),
    .TPBp(TPBp), 
    .TPBn(TPBn),
    
    .INDATA1f(INDATA1f),
    .INDATA20(INDATA20),
    .INDATA21(INDATA21),
    .OUTDATA1f(OUTDATA1f),
    .OUTDATA20(OUTDATA20),
    .OUTDATA21(OUTDATA21),
    
    
    .TPTRIG(TPTRIG),
          
    .INDATA46(INDATA46),
    .OUTDATA46(OUTDATA46),
    .INDATA47(INDATA47),
    .OUTDATA47(OUTDATA47),
    .INDATA48(INDATA48),
    .OUTDATA48(OUTDATA48),
    .INDATA49(INDATA49),
    .OUTDATA49(OUTDATA49),   
   
    
    .vp_in(vp_in),
    .vn_in(vn_in)
    );
    
    shignals signals(//PPASIC_SIGNAL
    .CLK200(CLK200_2),
    .CLK40(CLK40s),
    .CLK8M(CLK8),
    
    .Ach0p(Ach0p),
    .Ach0n(Ach0n),
    .Ach1p(Ach1p),
    .Ach1n(Ach1n),
    .Ach2p(Ach2p),
    .Ach2n(Ach2n),
    .Ach3p(Ach3p),
    .Ach3n(Ach3n),
    .Ach4p(Ach4p),
    .Ach4n(Ach4n),
    .Ach5p(Ach5p),
    .Ach5n(Ach5n),
    .Ach6p(Ach6p),
    .Ach6n(Ach6n),
    .Ach7p(Ach7p),
    .Ach7n(Ach7n),
    .Ach8p(Ach8p),
    .Ach8n(Ach8n),
    .Ach9p(Ach9p),
    .Ach9n(Ach9n),
    .Ach10p(Ach10p),
    .Ach10n(Ach10n),
    .Ach11p(Ach11p),
    .Ach11n(Ach11n),
    .Ach12p(Ach12p),
    .Ach12n(Ach12n),
    .Ach13p(Ach13p),
    .Ach13n(Ach13n),
    .Ach14p(Ach14p),
    .Ach14n(Ach14n),
    .Ach15p(Ach15p),
    .Ach15n(Ach15n),
    
    .Bch0p(Bch0p),
    .Bch0n(Bch0n),
    .Bch1p(Bch1p),
    .Bch1n(Bch1n),
    .Bch2p(Bch2p),
    .Bch2n(Bch2n),
    .Bch3p(Bch3p),
    .Bch3n(Bch3n),
    .Bch4p(Bch4p),
    .Bch4n(Bch4n),
    .Bch5p(Bch5p),
    .Bch5n(Bch5n),
    .Bch6p(Bch6p),
    .Bch6n(Bch6n),
    .Bch7p(Bch7p),
    .Bch7n(Bch7n),
    .Bch8p(Bch8p),
    .Bch8n(Bch8n),
    .Bch9p(Bch9p),
    .Bch9n(Bch9n),
    .Bch10p(Bch10p),
    .Bch10n(Bch10n),
    .Bch11p(Bch11p),
    .Bch11n(Bch11n),
    .Bch12p(Bch12p),
    .Bch12n(Bch12n),
    .Bch13p(Bch13p),
    .Bch13n(Bch13n),
    .Bch14p(Bch14p),
    .Bch14n(Bch14n),
    .Bch15p(Bch15p),
    .Bch15n(Bch15n),
        
        
    .Ach0(Ach0),
    .Ach1(Ach1),
    .Ach2(Ach2),
    .Ach3(Ach3),
    .Ach4(Ach4),
    .Ach5(Ach5),
    .Ach6(Ach6),
    .Ach7(Ach7),
    .Ach8(Ach8),
    .Ach9(Ach9),
    .Ach10(Ach10),
    .Ach11(Ach11),
    .Ach12(Ach12),
    .Ach13(Ach13),
    .Ach14(Ach14),
    .Ach15(Ach15),
    .Bch0(Bch0),
    .Bch1(Bch1),
    .Bch2(Bch2),
    .Bch3(Bch3),
    .Bch4(Bch4),
    .Bch5(Bch5),
    .Bch6(Bch6),
    .Bch7(Bch7),
    .Bch8(Bch8),
    .Bch9(Bch9),
    .Bch10(Bch10),
    .Bch11(Bch11),
    .Bch12(Bch12),
    .Bch13(Bch13),
    .Bch14(Bch14),
    .Bch15(Bch15),
    
        
    .INDATA22(INDATA22),
    .INDATA23(INDATA23),
    .INDATA24(INDATA24),
    .INDATA25(INDATA25),
    .INDATA26(INDATA26),
    .INDATA27(INDATA27),
    
    .OUTDATA22(OUTDATA22),
    .OUTDATA23(OUTDATA23),
    .OUTDATA24(OUTDATA24),
    .OUTDATA25(OUTDATA25),
    .OUTDATA26(OUTDATA26),
    .OUTDATA27(OUTDATA27),
    .OUTDATA28(OUTDATA28),
    .OUTDATA29(OUTDATA29),
    .OUTDATA2a(OUTDATA2a),
    .OUTDATA2b(OUTDATA2b),
    .OUTDATA2c(OUTDATA2c),
    .OUTDATA2d(OUTDATA2d),
    .OUTDATA2e(OUTDATA2e),
    .OUTDATA2f(OUTDATA2f),
    .OUTDATA30(OUTDATA30),
    .OUTDATA31(OUTDATA31),
    .OUTDATA32(OUTDATA32),
    .OUTDATA33(OUTDATA33),
    .OUTDATA34(OUTDATA34),
    .OUTDATA35(OUTDATA35),
    .OUTDATA36(OUTDATA36),
    .OUTDATA37(OUTDATA37),
    .OUTDATA38(OUTDATA38),
    .OUTDATA39(OUTDATA39),
    .OUTDATA3a(OUTDATA3a),
    .OUTDATA3b(OUTDATA3b),
    .OUTDATA3c(OUTDATA3c),
    .OUTDATA3d(OUTDATA3d),
    .OUTDATA3e(OUTDATA3e),
    .OUTDATA3f(OUTDATA3f),
    .OUTDATA40(OUTDATA40),
    .OUTDATA41(OUTDATA41),
     
    .INDATA4a(INDATA4a),
    .OUTDATA4a(OUTDATA4a),
    .INDATA4b(INDATA4b),
    .OUTDATA4b(OUTDATA4b),
    .INDATA4c(INDATA4c),
    .OUTDATA4c(OUTDATA4c),
    .INDATA4d(INDATA4d),
    .OUTDATA4d(OUTDATA4d),
    .INDATA4e (INDATA4e),
    .OUTDATA4e (OUTDATA4e),
    
    .sysclk (sysclk),
    .PP_CLK (PP_CLK),   
    .PP33ENb (PP33ENb),
    .PP18ENb (PP18ENb),
    .PP33EN(PP33EN),
    .PP18EN(PP18EN),
    .LED0 (LED0),
    .LED1 (LED1),
    .LED5 (LED5)          
    );
    
    
     delay_signal D_S(
    .CLK200(CLK200s),
    .CLK40(CLK40s),
    .delout(delout),
    .delin(delin),
       
    .INDATA42(INDATA42),
    .INDATA43(INDATA43),
    .INDATA44(INDATA44),
           
    .OUTDATA42(OUTDATA42),
    .OUTDATA43(OUTDATA43),
    .OUTDATA44(OUTDATA44)
       
          );
       
    
 
    endmodule