`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/02/04 15:09:14
// Design Name: 
// Module Name: delay_signal
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module delay_signal(
    input   sysclk,
    input   CLK200,
    input   CLK40,
    
    input   delout,
    output  reg delin,

    input   [7:0] INDATA42,
    input   [7:0] INDATA43,
    input   [7:0] INDATA44,
    
    output  reg [7:0] OUTDATA42,
    output  reg [7:0] OUTDATA43,
    output  reg [7:0] OUTDATA44

    );
    
    
    
        
         
    
    
    //one_shot_for_delay
        reg [31:0] s_cont = 32'h00000000;
         always@(posedge CLK40)begin//delin
          if(INDATA43[7:0] == 8'h03) begin
          s_cont <= 32'h0;
          delin <= 1'b0;
          end
         
          else if(INDATA42[7:0] == 8'h03) begin
          if (s_cont < 32'h00100000/*l̗]n*/ ) begin
           s_cont <= s_cont + 32'h1;
           if(delin == 0 & s_cont == 32'h00000001) begin
           delin <= 1;
           end
           else if(delin == 1 & s_cont == 32'h00000191) begin 
           delin <= 0;
           end
           else s_cont <= s_cont + 32'h1;
          end
          else if (s_cont == 32'h00100000/*l̗]n*/ ) begin
           s_cont <= s_cont;
          end
          
          end
          else begin
          s_cont <= 32'h0;
          delin <= 1'b0;
          end
         
         end
         
         reg [7:0] d_cont = 8'h00;
         always@(posedge CLK200)begin//delay_cont
         
          if (INDATA44 == 8'h03) begin
          d_cont <= 8'h00;
          end
         
          else if(delin ==1 & delout ==0) begin
          d_cont <= d_cont + 8'h1;
          end
          else if(delin ==1 & delout ==1) begin
          OUTDATA42 <=  d_cont;
          end
          else  d_cont <= 8'h00;
         
         end
         
         
         
endmodule
