`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/05/07 18:27:10
// Design Name: 
// Module Name: pp_power
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module pp_power(
  input sysclk,
  input CLK,
  input [7:0] INDATA4e,
  output PP_CLK,
  output reg BUFT=1'b0,
  output reg [7:0] OUTDATA4e,
  output reg [0:0] PP33ENb =1'b0,
  output reg [0:0] PP18ENb =1'b0,
  output reg LED0 = 1'b1,
  output reg LED1 = 1'b0,
  output reg [0:0] PP33EN =1'b1,
  output reg [0:0] PP18EN =1'b1

    );
    
   
    OBUFT   ppclock (.I(sysclk),.O(PP_CLK),.T(BUFT));//clkMto PP ASIC
    
    always@(posedge CLK)begin
     if(INDATA4e[7:0] == 8'h03) begin
       PP33ENb =1'b1;
       PP18ENb =1'b1;
       PP33EN =1'b0;
       PP18EN =1'b0;
       LED0 <= 1'b0;
       BUFT <=1'b1;
       //LED1 <= 1'b0;
     end
     /*else if(INDATA4e[7:0] == 8'h02) begin//Jp
       LED0 = 1'b0;
       BUFT <=1'b1;
     end*/
     else  begin
       PP33ENb =1'b0;
       PP18ENb =1'b0;
       PP33EN =1'b1;
       PP18EN =1'b1;
       LED0 <= 1'b1;
       BUFT <=1'b0;
       //LED1 <= 1'b1;
     end
    end
    
endmodule
