`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/02/03 10:25:10
// Design Name: 
// Module Name: shignals
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module shignals(
    input   CLK200,
    input   CLK40,
    //input   CLK10M,
    //input   CLK7M,
    input   CLK8M,
    //input   flag,

    //chA_signal_output
    output Ach0p,
    output Ach0n,
    output Ach1p,
    output Ach1n,
    output Ach2p,
    output Ach2n,
    output Ach3p,
    output Ach3n,
    output Ach4p,
    output Ach4n,
    output Ach5p,
    output Ach5n,
    output Ach6p,
    output Ach6n,
    output Ach7p,
    output Ach7n,
    output Ach8p,
    output Ach8n,
    output Ach9p,
    output Ach9n,
    output Ach10p,
    output Ach10n,
    output Ach11p,
    output Ach11n,
    output Ach12p,
    output Ach12n,
    output Ach13p,
    output Ach13n,
    output Ach14p,
    output Ach14n,
    output Ach15p,
    output Ach15n,
    
    //chB_signal_output
    output Bch0p,
    output Bch0n,
    output Bch1p,
    output Bch1n,
    output Bch2p,
    output Bch2n,
    output Bch3p,
    output Bch3n,
    output Bch4p,
    output Bch4n,
    output Bch5p,
    output Bch5n,
    output Bch6p,
    output Bch6n,
    output Bch7p,
    output Bch7n,
    output Bch8p,
    output Bch8n,
    output Bch9p,
    output Bch9n,
    output Bch10p,
    output Bch10n,
    output Bch11p,
    output Bch11n,
    output Bch12p,
    output Bch12n,
    output Bch13p,
    output Bch13n,
    output Bch14p,
    output Bch14n,
    output Bch15p,
    output Bch15n,
    
    //chA_rx_signal
    input Ach0,
    input Ach1,
    input Ach2,
    input Ach3,
    input Ach4,
    input Ach5,
    input Ach6,
    input Ach7,
    input Ach8,
    input Ach9,
    input Ach10,
    input Ach11,
    input Ach12,
    input Ach13,
    input Ach14,
    input Ach15,
    
    //chB_rx_signal
    input Bch0,
    input Bch1,
    input Bch2,
    input Bch3,
    input Bch4,
    input Bch5,
    input Bch6,
    input Bch7,
    input Bch8,
    input Bch9,
    input Bch10,
    input Bch11,
    input Bch12,
    input Bch13,
    input Bch14,
    input Bch15,
    
    //input sysclk,
    
    input [7:0] INDATA22,
    input [7:0] INDATA23,
    input [7:0] INDATA24,
    input [7:0] INDATA25,
    input [7:0] INDATA26,
    input [7:0] INDATA27,
    
    output reg [7:0] OUTDATA22,
    output reg [7:0] OUTDATA23,
    output reg [7:0] OUTDATA24,
    output reg [7:0] OUTDATA25,
    output reg [7:0] OUTDATA26,
    output reg [7:0] OUTDATA27,
    output reg [7:0] OUTDATA28,
    output reg [7:0] OUTDATA29,
    output reg [7:0] OUTDATA2a,
    output reg [7:0] OUTDATA2b,
    output reg [7:0] OUTDATA2c,
    output reg [7:0] OUTDATA2d,
    output reg [7:0] OUTDATA2e,
    output reg [7:0] OUTDATA2f,
    output reg [7:0] OUTDATA30,
    output reg [7:0] OUTDATA31,
    output reg [7:0] OUTDATA32,
    output reg [7:0] OUTDATA33,
    output reg [7:0] OUTDATA34,
    output reg [7:0] OUTDATA35,
    output reg [7:0] OUTDATA36,
    output reg [7:0] OUTDATA37,
    output reg [7:0] OUTDATA38,
    output reg [7:0] OUTDATA39,
    output reg [7:0] OUTDATA3a,
    output reg [7:0] OUTDATA3b,
    output reg [7:0] OUTDATA3c,
    output reg [7:0] OUTDATA3d,
    output reg [7:0] OUTDATA3e,
    output reg [7:0] OUTDATA3f,
    output reg [7:0] OUTDATA40,
    output reg [7:0] OUTDATA41,
    
    input [7:0] INDATA4a,
    output reg [7:0] OUTDATA4a,
    input [7:0] INDATA4b,
    output reg [7:0] OUTDATA4b,
    input [7:0] INDATA4c,
    output reg [7:0] OUTDATA4c,
    input [7:0] INDATA4d,
    output reg [7:0] OUTDATA4d,
    input [7:0] INDATA4e,
    output OUTDATA4e,
    
    input sysclk,
    output PP_CLK,
    output PP33ENb,
    output PP18ENb,
    output PP33EN,
    output PP18EN,
    output LED0,
    output LED1,
    output reg LED5

    );
    
   
    wire BUFT;
    
    
    //for_one_shot_signal
        reg [31:0] s_cont = 32'h00000000;
        reg START = 1'b0;
         always@(posedge CLK40)begin
          if(INDATA27[7:0] == 8'h03) begin
            s_cont <= 32'h0;
            START <= 1'b0;
            LED5 <= 1'b0;
          end
         
          else if(INDATA26[7:0] == 8'h03) begin
           if(START == 0 & s_cont == 32'h00000000) begin
            START <= 1;
            LED5 <= 1'b1;
           end
           else if(START == 1 & s_cont == 32'h00000000) begin 
            START <= 0;
            LED5 <= 1'b1;
            s_cont <= 32'h00000001;
           end
           else if(s_cont == 32'h00000001) begin 
            START <= 0;
            LED5 <= 1'b1;
            s_cont <= s_cont + 32'h1;
           end
           else if (s_cont == 32'h01000000/*l̗]n*/ ) begin
            s_cont <= s_cont;
            LED5 <= 1'b0;
           end
           else s_cont <= s_cont + 32'h1;
          end
          else begin
            s_cont <= 32'h0;
            START <= 1'b0;
          end
         
         end
    
        //----------------------------------------------------------------------------------------
        
        //for_Gate_Width
        reg [3:0] flag = 4'h0;
        reg [7:0] f_count = 8'h00;
         always@(posedge CLK200)begin
           if(f_count == 8'h5) f_count <= 8'h1;
           else  f_count <= f_count  + 8'h1;
         end
        
        reg [15:0] g_cont = 16'h0000;
        reg STARTg = 1'b0;
         always@(posedge CLK200)begin
         
          if(INDATA4d[7:0] == 8'h03) begin
           g_cont <= 16'h0;
           STARTg <= 1'b0;
          end
                
          if(INDATA4b[7:0] == 8'h01) begin
           if(INDATA4c[7:0] == 8'h03) begin
            if(STARTg == 0 & g_cont == 16'h0000 & f_count == 8'h05) begin
              STARTg <= 1;
            end
            else if(STARTg == 1 & g_cont == 16'h0000) begin 
              STARTg <= 1;
              g_cont <= 16'h0001;
            end
            else if(STARTg == 1 & g_cont == 16'h0001) begin 
              STARTg <= 0;
              g_cont <= g_cont + 16'h1;
            end
            else if (g_cont == 16'h0020/*l̗]n*/ ) begin
              STARTg <= 0;
              g_cont <= g_cont;
            end
            else if(STARTg == 0 & g_cont == 16'h0000)  g_cont <= g_cont; 
            else g_cont <= g_cont + 32'h1;
           end
          end
                
          else if(INDATA4b[7:0] == 8'h02) begin
           if(INDATA4c[7:0] == 8'h03) begin
             if(STARTg == 0 & g_cont == 16'h0000 & f_count == 8'h01) begin
             STARTg <= 1;
             end
             else if(STARTg == 1 & g_cont == 16'h0000) begin 
             STARTg <= 1;
             g_cont <= 16'h0001;
             end
             else if(STARTg == 1 & g_cont == 16'h0001) begin 
                 STARTg <= 1;
                 g_cont <= g_cont + 16'h1;
             end
             else if (g_cont == 16'h0020/*l̗]n*/ ) begin
                   STARTg <= 0;
                   g_cont <= g_cont;
             end
             else if(STARTg == 0 & g_cont == 16'h0000)  g_cont <= g_cont; 
             else g_cont <= g_cont + 16'h1;
            end
          end
                
          else if(INDATA4b[7:0] == 8'h03) begin
            if(INDATA4c[7:0] == 8'h03) begin
             if(STARTg == 0 & g_cont == 16'h0000 & f_count == 8'h02) begin
             STARTg <= 1;
             end
             else if(STARTg == 1 & g_cont == 16'h0000) begin 
               STARTg <= 1;
               g_cont <= 32'h0001;
             end
             else if(STARTg == 1 & g_cont == 32'h0001) begin 
               STARTg <= 1;
               g_cont <= g_cont + 16'h1;
             end
             else if (g_cont == 32'h0020/*l̗]n*/ ) begin
               STARTg <= 0;
               g_cont <= g_cont;
             end
             else if(STARTg == 0 & g_cont == 16'h0000)  g_cont <= g_cont; 
             else g_cont <= g_cont + 16'h1;
            end
          end
          
          else if(INDATA4b[7:0] == 8'h04) begin
            if(INDATA4c[7:0] == 8'h03) begin
               if(STARTg == 0 & g_cont == 16'h0000 & f_count == 8'h03) begin
                 STARTg <= 1;
               end
               else if(STARTg == 1 & g_cont == 16'h0000) begin 
                  STARTg <= 1;
                  g_cont <= 16'h0001;
                end
                else if(STARTg == 1 & g_cont == 16'h0001) begin 
                  STARTg <= 1;
                  g_cont <= g_cont + 16'h1;
                end
                else if (g_cont == 16'h0020/*l̗]n*/ ) begin
                   STARTg <= 0;
                   g_cont <= g_cont;
                end
                else if(STARTg == 0 & g_cont == 16'h0000)  g_cont <= g_cont; 
                else g_cont <= g_cont + 16'h1;
               end
           end
                 
           else if(INDATA4b[7:0] == 8'h05) begin
             if(INDATA4c[7:0] == 8'h03) begin
               if(STARTg == 0 & g_cont == 16'h0000 & f_count == 8'h04) begin
                     STARTg <= 1;
               end
               else if(STARTg == 1 & g_cont == 16'h0000) begin 
                     STARTg <= 1;
                     g_cont <= 16'h0001;
               end
               else if(STARTg == 1 & g_cont == 16'h0001) begin 
                     STARTg <= 0;
                     g_cont <= g_cont + 16'h1;
               end
               else if (g_cont == 16'h0020/*l̗]n*/ ) begin
                     STARTg <= 0;
                     g_cont <= g_cont;
               end
               else if(STARTg == 0 & g_cont == 16'h0000)  g_cont <= g_cont; 
               else g_cont <= g_cont + 16'h1;
             end
           end
                 
           else begin
                 g_cont <= 16'h0;
                 STARTg <= 1'b0;
           end
                
          end
        
        
        
    //----------------------------------------------------------------------------------------
        
    
        
    //chA  
    reg Asig0 = 1'b0;
    OBUFTDS    ua0 (.I(Asig0),.O(Ach0p),.OB(Ach0n),.T(BUFT));//MMto PP ASIC
    reg Asig1 = 1'b0;
    OBUFTDS    ua1 (.I(Asig1),.O(Ach1p),.OB(Ach1n),.T(BUFT));//MMto PP ASIC
    reg Asig2 = 1'b0;
    OBUFTDS    ua2 (.I(Asig2),.O(Ach2p),.OB(Ach2n),.T(BUFT));//MMto PP ASIC    
    reg Asig3 = 1'b0;
    OBUFTDS    ua3 (.I(Asig3),.O(Ach3p),.OB(Ach3n),.T(BUFT));//MMto PP ASIC
    reg Asig4 = 1'b0;
    OBUFTDS    ua4 (.I(Asig4),.O(Ach4p),.OB(Ach4n),.T(BUFT));//MMto PP ASIC
    reg Asig5 = 1'b0;
    OBUFTDS    ua5 (.I(Asig5),.O(Ach5p),.OB(Ach5n),.T(BUFT));//MMto PP ASIC
    reg Asig6 = 1'b0;
    OBUFTDS    ua6 (.I(Asig6),.O(Ach6p),.OB(Ach6n),.T(BUFT));//MMto PP ASIC
    reg Asig7 = 1'b0;
    OBUFTDS    ua7 (.I(Asig7),.O(Ach7p),.OB(Ach7n),.T(BUFT));//MMto PP ASIC
    reg Asig8 = 1'b0;
    OBUFTDS    ua8 (.I(Asig8),.O(Ach8p),.OB(Ach8n),.T(BUFT));//MMto PP ASIC
    reg Asig9 = 1'b0;
    OBUFTDS    ua9 (.I(Asig9),.O(Ach9p),.OB(Ach9n),.T(BUFT));//MMto PP ASIC
    reg Asig10 = 1'b0;
    OBUFTDS    ua10 (.I(Asig10),.O(Ach10p),.OB(Ach10n),.T(BUFT));//MMto PP ASIC    
    reg Asig11 = 1'b0;
    OBUFTDS    ua11 (.I(Asig11),.O(Ach11p),.OB(Ach11n),.T(BUFT));//MMto PP ASIC
    reg Asig12 = 1'b0;
    OBUFTDS    ua12 (.I(Asig12),.O(Ach12p),.OB(Ach12n),.T(BUFT));//MMto PP ASIC
    reg Asig13 = 1'b0;
    OBUFTDS    ua13 (.I(Asig13),.O(Ach13p),.OB(Ach13n),.T(BUFT));//MMto PP ASIC
    reg Asig14 = 1'b0;
    OBUFTDS    ua14 (.I(Asig14),.O(Ach14p),.OB(Ach14n),.T(BUFT));//MMto PP ASIC
    reg Asig15 = 1'b0;
    OBUFTDS    ua15 (.I(Asig15),.O(Ach15p),.OB(Ach15n),.T(BUFT));//MMto PP ASIC
    
    //chB
    reg Bsig0 = 1'b0;
    OBUFTDS    ub0 (.I(Bsig0),.O(Bch0p),.OB(Bch0n),.T(BUFT));//MMto PP ASIC
    reg Bsig1 = 1'b0;
    OBUFTDS    ub1 (.I(Bsig1),.O(Bch1p),.OB(Bch1n),.T(BUFT));//MMto PP ASIC
    reg Bsig2 = 1'b0;
    OBUFTDS    ub2 (.I(Bsig2),.O(Bch2p),.OB(Bch2n),.T(BUFT));//MMto PP ASIC    
    reg Bsig3 = 1'b0;
    OBUFTDS    ub3 (.I(Bsig3),.O(Bch3p),.OB(Bch3n),.T(BUFT));//MMto PP ASIC
    reg Bsig4 = 1'b0;
    OBUFTDS    ub4 (.I(Bsig4),.O(Bch4p),.OB(Bch4n),.T(BUFT));//MMto PP ASIC
    reg Bsig5 = 1'b0;
    OBUFTDS    ub5 (.I(Bsig5),.O(Bch5p),.OB(Bch5n),.T(BUFT));//MMto PP ASIC
    reg Bsig6 = 1'b0;
    OBUFTDS    ub6 (.I(Bsig6),.O(Bch6p),.OB(Bch6n),.T(BUFT));//MMto PP ASIC
    reg Bsig7 = 1'b0;
    OBUFTDS    ub7 (.I(Bsig7),.O(Bch7p),.OB(Bch7n),.T(BUFT));//MMto PP ASIC
    reg Bsig8 = 1'b0;
    OBUFTDS    ub8 (.I(Bsig8),.O(Bch8p),.OB(Bch8n),.T(BUFT));//MMto PP ASIC
    reg Bsig9 = 1'b0;
    OBUFTDS    ub9 (.I(Bsig9),.O(Bch9p),.OB(Bch9n),.T(BUFT));//MMto PP ASIC
    reg Bsig10 = 1'b0;
    OBUFTDS    ub10 (.I(Bsig10),.O(Bch10p),.OB(Bch10n),.T(BUFT));//MMto PP ASIC    
    reg Bsig11 = 1'b0;
    OBUFTDS    ub11 (.I(Bsig11),.O(Bch11p),.OB(Bch11n),.T(BUFT));//MMto PP ASIC
    reg Bsig12 = 1'b0;
    OBUFTDS    ub12 (.I(Bsig12),.O(Bch12p),.OB(Bch12n),.T(BUFT));//MMto PP ASIC
    reg Bsig13 = 1'b0;
    OBUFTDS    ub13 (.I(Bsig13),.O(Bch13p),.OB(Bch13n),.T(BUFT));//MMto PP ASIC
    reg Bsig14 = 1'b0;
    OBUFTDS    ub14 (.I(Bsig14),.O(Bch14p),.OB(Bch14n),.T(BUFT));//MMto PP ASIC
    reg Bsig15 = 1'b0;
    OBUFTDS    ub15 (.I(Bsig15),.O(Bch15p),.OB(Bch15n),.T(BUFT));//MMto PP ASIC
    
    /*wire Ach0;
    IBUF_IBUFDISABLE ia0 (.I(Ach0I),.O(Ach0),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach1;
    IBUF_IBUFDISABLE ia1 (.I(Ach1I),.O(Ach1),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach2;
    IBUF_IBUFDISABLE ia2 (.I(Ach2I),.O(Ach2),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach3;
    IBUF_IBUFDISABLE ia3 (.I(Ach3I),.O(Ach3),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach4;
    IBUF_IBUFDISABLE ia4 (.I(Ach4I),.O(Ach4),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach5;
    IBUF_IBUFDISABLE ia5 (.I(Ach5I),.O(Ach5),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach6;
    IBUF_IBUFDISABLE ia6 (.I(Ach6I),.O(Ach6),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach7;
    IBUF_IBUFDISABLE ia7 (.I(Ach7I),.O(Ach7),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach8;
    IBUF_IBUFDISABLE ia8 (.I(Ach8I),.O(Ach8),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach9;
    IBUF_IBUFDISABLE ia9 (.I(Ach9I),.O(Ach9),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach10;
    IBUF_IBUFDISABLE ia10 (.I(Ach10I),.O(Ach10),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach11;
    IBUF_IBUFDISABLE ia11 (.I(Ach11I),.O(Ach11),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach12;
    IBUF_IBUFDISABLE ia12 (.I(Ach12I),.O(Ach12),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach13;
    IBUF_IBUFDISABLE ia13 (.I(Ach13I),.O(Ach13),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach14;
    IBUF_IBUFDISABLE ia14 (.I(Ach14I),.O(Ach14),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Ach15;
    IBUF_IBUFDISABLE ia15 (.I(Ach15I),.O(Ach15),.IBUFDISABLE(BUFT));//MMform PP ASIC
    
    
    
    wire Bch0;
    IBUF_IBUFDISABLE ib0 (.I(Bch0I),.O(Bch0),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch1;
    IBUF_IBUFDISABLE ib1 (.I(Bch1I),.O(Bch1),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch2;
    IBUF_IBUFDISABLE ib2 (.I(Bch2I),.O(Bch2),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch3;
    IBUF_IBUFDISABLE ib3 (.I(Bch3I),.O(Bch3),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch4;
    IBUF_IBUFDISABLE ib4 (.I(Bch4I),.O(Bch4),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch5;
    IBUF_IBUFDISABLE ib5 (.I(Bch5I),.O(Bch5),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch6;
    IBUF_IBUFDISABLE ib6 (.I(Bch6I),.O(Bch6),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch7;
    IBUF_IBUFDISABLE ib7 (.I(Bch7I),.O(Bch7),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch8;
    IBUF_IBUFDISABLE ib8 (.I(Bch8I),.O(Bch8),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch9;
    IBUF_IBUFDISABLE ib9 (.I(Bch9I),.O(Bch9),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch10;
    IBUF_IBUFDISABLE ib10 (.I(Bch10I),.O(Bch10),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch11;
    IBUF_IBUFDISABLE ib11 (.I(Bch11I),.O(Bch11),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch12;
    IBUF_IBUFDISABLE ib12 (.I(Bch12I),.O(Bch12),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch13;
    IBUF_IBUFDISABLE ib13 (.I(Bch13I),.O(Bch13),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch14;
    IBUF_IBUFDISABLE ib14 (.I(Bch14I),.O(Bch14),.IBUFDISABLE(BUFT));//MMform PP ASIC
    wire Bch15;
    IBUF_IBUFDISABLE ib15 (.I(Bch15I),.O(Bch15),.IBUFDISABLE(BUFT));//MMform PP ASIC*/
    
    //10k
    wire CLK10k;//9.77kHz
    wire CLK80k;//78.16kHz
    /*wire CLK5M;//5MHz
    wire CLK10M;
    wire CLK20M;
    wire CLK40M;*/
    reg [12:0] q;
    assign CLK10k = q[12];
    assign CLK80k = q[9];
    /*assign CLK5M = q[3];
    assign CLK10M = q[2];
    assign CLK20M = q[1];
    assign CLK40M = q[0];*/
    always@(posedge CLK40)begin
    q <= q + 1'b1;
    end
    wire CLK1M;
    /*wire CLK2M;
    wire CLK4M;*/
    reg [3:0] q1;
    assign CLK1M = q1[3];
    /*assign CLK2M = q1[2];
    assign CLK4M = q1[1];*/
    always@(posedge CLK8M)begin
       q1 <= q1 + 1'b1;
    end
                            
    
     always@(posedge CLK200)begin //Ach_sig_con
        if(INDATA4a == 8'h01) begin
            Asig0 <= CLK10k;
            Asig1 <= CLK10k;
            Asig2 <= CLK10k;
            Asig3 <= CLK10k;
            Asig4 <= CLK10k;
            Asig5 <= CLK10k;
            Asig6 <= CLK10k;
            Asig7 <= CLK10k;
            Asig8 <= CLK10k;
            Asig9 <= CLK10k;
            Asig10 <= CLK10k;
            Asig11 <= CLK10k;
            Asig12 <= CLK10k;
            Asig13 <= CLK10k;
            Asig14 <= CLK10k;
            Asig15 <= CLK10k;
            Bsig0 <= CLK10k;
            Bsig1 <= CLK10k;
            Bsig2 <= CLK10k;
            Bsig3 <= CLK10k;
            Bsig4 <= CLK10k;
            Bsig5 <= CLK10k;
            Bsig6 <= CLK10k;
            Bsig7 <= CLK10k;
            Bsig8 <= CLK10k;
            Bsig9 <= CLK10k;
            Bsig10 <= CLK10k;
            Bsig11 <= CLK10k;
            Bsig12 <= CLK10k;
            Bsig13 <= CLK10k;
            Bsig14 <= CLK10k;
            Bsig15 <= CLK10k;
        end
        
        if(INDATA4a == 8'h02) begin
            Asig0 <= CLK80k;
            Asig1 <= CLK80k;
            Asig2 <= CLK80k;
            Asig3 <= CLK80k;
            Asig4 <= CLK80k;
            Asig5 <= CLK80k;
            Asig6 <= CLK80k;
            Asig7 <= CLK80k;
            Asig8 <= CLK80k;
            Asig9 <= CLK80k;
            Asig10 <= CLK80k;
            Asig11 <= CLK80k;
            Asig12 <= CLK80k;
            Asig13 <= CLK80k;
            Asig14 <= CLK80k;
            Asig15 <= CLK80k;
            Bsig0 <= CLK80k;
            Bsig1 <= CLK80k;
            Bsig2 <= CLK80k;
            Bsig3 <= CLK80k;
            Bsig4 <= CLK80k;
            Bsig5 <= CLK80k;
            Bsig6 <= CLK80k;
            Bsig7 <= CLK80k;
            Bsig8 <= CLK80k;
            Bsig9 <= CLK80k;
            Bsig10 <= CLK80k;
            Bsig11 <= CLK80k;
            Bsig12 <= CLK80k;
            Bsig13 <= CLK80k;
            Bsig14 <= CLK80k;
            Bsig15 <= CLK80k;
        end
        if(INDATA4a == 8'h03) begin
            Asig0 <= CLK1M;
            Asig1 <= CLK1M;
            Asig2 <= CLK1M;
            Asig3 <= CLK1M;
            Asig4 <= CLK1M;
            Asig5 <= CLK1M;
            Asig6 <= CLK1M;
            Asig7 <= CLK1M;
            Asig8 <= CLK1M;
            Asig9 <= CLK1M;
            Asig10 <= CLK1M;
            Asig11 <= CLK1M;
            Asig12 <= CLK1M;
            Asig13 <= CLK1M;
            Asig14 <= CLK1M;
            Asig15 <= CLK1M;
            Bsig0 <= CLK1M;
            Bsig1 <= CLK1M;
            Bsig2 <= CLK1M;
            Bsig3 <= CLK1M;
            Bsig4 <= CLK1M;
            Bsig5 <= CLK1M;
            Bsig6 <= CLK1M;
            Bsig7 <= CLK1M;
            Bsig8 <= CLK1M;
            Bsig9 <= CLK1M;
            Bsig10 <= CLK1M;
            Bsig11 <= CLK1M;
            Bsig12 <= CLK1M;
            Bsig13 <= CLK1M;
            Bsig14 <= CLK1M;
            Bsig15 <= CLK1M;
        end
        //Jp
        /*if(INDATA4a == 8'h04) begin
                        Asig0 <= CLK2M;
                        Asig1 <= CLK2M;
                        Asig2 <= CLK2M;
                        Asig3 <= CLK2M;
                        Asig4 <= CLK2M;
                        Asig5 <= CLK2M;
                        Asig6 <= CLK2M;
                        Asig7 <= CLK2M;
                        Asig8 <= CLK2M;
                        Asig9 <= CLK2M;
                        Asig10 <= CLK2M;
                        Asig11 <= CLK2M;
                        Asig12 <= CLK2M;
                        Asig13 <= CLK2M;
                        Asig14 <= CLK2M;
                        Asig15 <= CLK2M;
                        Bsig0 <= CLK2M;
                        Bsig1 <= CLK2M;
                        Bsig2 <= CLK2M;
                        Bsig3 <= CLK2M;
                        Bsig4 <= CLK2M;
                        Bsig5 <= CLK2M;
                        Bsig6 <= CLK2M;
                        Bsig7 <= CLK2M;
                        Bsig8 <= CLK2M;
                        Bsig9 <= CLK2M;
                        Bsig10 <= CLK2M;
                        Bsig11 <= CLK2M;
                        Bsig12 <= CLK2M;
                        Bsig13 <= CLK2M;
                        Bsig14 <= CLK2M;
                        Bsig15 <= CLK2M;
        end
        if(INDATA4a == 8'h05) begin
                        Asig0 <= CLK4M;
                        Asig1 <= CLK4M;
                        Asig2 <= CLK4M;
                        Asig3 <= CLK4M;
                        Asig4 <= CLK4M;
                        Asig5 <= CLK4M;
                        Asig6 <= CLK4M;
                        Asig7 <= CLK4M;
                        Asig8 <= CLK4M;
                        Asig9 <= CLK4M;
                        Asig10 <= CLK4M;
                        Asig11 <= CLK4M;
                        Asig12 <= CLK4M;
                        Asig13 <= CLK4M;
                        Asig14 <= CLK4M;
                        Asig15 <= CLK4M;
                        Bsig0 <= CLK4M;
                        Bsig1 <= CLK4M;
                        Bsig2 <= CLK4M;
                        Bsig3 <= CLK4M;
                        Bsig4 <= CLK4M;
                        Bsig5 <= CLK4M;
                        Bsig6 <= CLK4M;
                        Bsig7 <= CLK4M;
                        Bsig8 <= CLK4M;
                        Bsig9 <= CLK4M;
                        Bsig10 <= CLK4M;
                        Bsig11 <= CLK4M;
                        Bsig12 <= CLK4M;
                        Bsig13 <= CLK4M;
                        Bsig14 <= CLK4M;
                        Bsig15 <= CLK4M;
        end
        if(INDATA4a == 8'h06) begin
                        Asig0 <= CLK5M;
                        Asig1 <= CLK5M;
                        Asig2 <= CLK5M;
                        Asig3 <= CLK5M;
                        Asig4 <= CLK5M;
                        Asig5 <= CLK5M;
                        Asig6 <= CLK5M;
                        Asig7 <= CLK5M;
                        Asig8 <= CLK5M;
                        Asig9 <= CLK5M;
                        Asig10 <= CLK5M;
                        Asig11 <= CLK5M;
                        Asig12 <= CLK5M;
                        Asig13 <= CLK5M;
                        Asig14 <= CLK5M;
                        Asig15 <= CLK5M;
                        Bsig0 <= CLK5M;
                        Bsig1 <= CLK5M;
                        Bsig2 <= CLK5M;
                        Bsig3 <= CLK5M;
                        Bsig4 <= CLK5M;
                        Bsig5 <= CLK5M;
                        Bsig6 <= CLK5M;
                        Bsig7 <= CLK5M;
                        Bsig8 <= CLK5M;
                        Bsig9 <= CLK5M;
                        Bsig10 <= CLK5M;
                        Bsig11 <= CLK5M;
                        Bsig12 <= CLK5M;
                        Bsig13 <= CLK5M;
                        Bsig14 <= CLK5M;
                        Bsig15 <= CLK5M;
        end
        if(INDATA4a == 8'h07) begin
                        Asig0 <= CLK8M;
                        Asig1 <= CLK8M;
                        Asig2 <= CLK8M;
                        Asig3 <= CLK8M;
                        Asig4 <= CLK8M;
                        Asig5 <= CLK8M;
                        Asig6 <= CLK8M;
                        Asig7 <= CLK8M;
                        Asig8 <= CLK8M;
                        Asig9 <= CLK8M;
                        Asig10 <= CLK8M;
                        Asig11 <= CLK8M;
                        Asig12 <= CLK8M;
                        Asig13 <= CLK8M;
                        Asig14 <= CLK8M;
                        Asig15 <= CLK8M;
                        Bsig0 <= CLK8M;
                        Bsig1 <= CLK8M;
                        Bsig2 <= CLK8M;
                        Bsig3 <= CLK8M;
                        Bsig4 <= CLK8M;
                        Bsig5 <= CLK8M;
                        Bsig6 <= CLK8M;
                        Bsig7 <= CLK8M;
                        Bsig8 <= CLK8M;
                        Bsig9 <= CLK8M;
                        Bsig10 <= CLK8M;
                        Bsig11 <= CLK8M;
                        Bsig12 <= CLK8M;
                        Bsig13 <= CLK8M;
                        Bsig14 <= CLK8M;
                        Bsig15 <= CLK8M;
        end
        if(INDATA4a == 8'h08) begin
        Asig0 <= CLK10M;
        Asig1 <= CLK10M;
        Asig2 <= CLK10M;
        Asig3 <= CLK10M;
        Asig4 <= CLK10M;
        Asig5 <= CLK10M;
        Asig6 <= CLK10M;
        Asig7 <= CLK10M;
        Asig8 <= CLK10M;
        Asig9 <= CLK10M;
        Asig10 <= CLK10M;
        Asig11 <= CLK10M;
        Asig12 <= CLK10M;
        Asig13 <= CLK10M;
        Asig14 <= CLK10M;
        Asig15 <= CLK10M;
        Bsig0 <= CLK10M;
        Bsig1 <= CLK10M;
        Bsig2 <= CLK10M;
        Bsig3 <= CLK10M;
        Bsig4 <= CLK10M;
        Bsig5 <= CLK10M;
        Bsig6 <= CLK10M;
        Bsig7 <= CLK10M;
        Bsig8 <= CLK10M;
        Bsig9 <= CLK10M;
        Bsig10 <= CLK10M;
        Bsig11 <= CLK10M;
        Bsig12 <= CLK10M;
        Bsig13 <= CLK10M;
        Bsig14 <= CLK10M;
        Bsig15 <= CLK10M;
        end
       if(INDATA4a == 8'h09) begin
               Asig0 <= CLK20M;
               Asig1 <= CLK20M;
               Asig2 <= CLK20M;
               Asig3 <= CLK20M;
               Asig4 <= CLK20M;
               Asig5 <= CLK20M;
               Asig6 <= CLK20M;
               Asig7 <= CLK20M;
               Asig8 <= CLK20M;
               Asig9 <= CLK20M;
               Asig10 <= CLK20M;
               Asig11 <= CLK20M;
               Asig12 <= CLK20M;
               Asig13 <= CLK20M;
               Asig14 <= CLK20M;
               Asig15 <= CLK20M;
               Bsig0 <= CLK20M;
               Bsig1 <= CLK20M;
               Bsig2 <= CLK20M;
               Bsig3 <= CLK20M;
               Bsig4 <= CLK20M;
               Bsig5 <= CLK20M;
               Bsig6 <= CLK20M;
               Bsig7 <= CLK20M;
               Bsig8 <= CLK20M;
               Bsig9 <= CLK20M;
               Bsig10 <= CLK20M;
               Bsig11 <= CLK20M;
               Bsig12 <= CLK20M;
               Bsig13 <= CLK20M;
               Bsig14 <= CLK20M;
               Bsig15 <= CLK20M;
               end
               
        if(INDATA4a == 8'h0a) begin
                              Asig0 <= CLK40M;
                              Asig1 <= CLK40M;
                              Asig2 <= CLK40M;
                              Asig3 <= CLK40M;
                              Asig4 <= CLK40M;
                              Asig5 <= CLK40M;
                              Asig6 <= CLK40M;
                              Asig7 <= CLK40M;
                              Asig8 <= CLK40M;
                              Asig9 <= CLK40M;
                              Asig10 <= CLK40M;
                              Asig11 <= CLK40M;
                              Asig12 <= CLK40M;
                              Asig13 <= CLK40M;
                              Asig14 <= CLK40M;
                              Asig15 <= CLK40M;
                              Bsig0 <= CLK40M;
                              Bsig1 <= CLK40M;
                              Bsig2 <= CLK40M;
                              Bsig3 <= CLK40M;
                              Bsig4 <= CLK40M;
                              Bsig5 <= CLK40M;
                              Bsig6 <= CLK40M;
                              Bsig7 <= CLK40M;
                              Bsig8 <= CLK40M;
                              Bsig9 <= CLK40M;
                              Bsig10 <= CLK40M;
                              Bsig11 <= CLK40M;
                              Bsig12 <= CLK40M;
                              Bsig13 <= CLK40M;
                              Bsig14 <= CLK40M;
                              Bsig15 <= CLK40M;
        end*/
        if(INDATA4a == 8'h00) begin
        
            if(INDATA25 == 8'h0f) begin
                Asig0 <= START;
                Asig1 <= START;
                Asig2 <= START;
                Asig3 <= START;
                Asig4 <= START;
                Asig5 <= START;
                Asig6 <= START;
                Asig7 <= START;
                Asig8 <= START;
                Asig9 <= START;
                Asig10 <= START;
                Asig11 <= START;
                Asig12 <= START;
                Asig13 <= START;
                Asig14 <= START;
                Asig15 <= START;
                Bsig0 <= START;
                Bsig1 <= START;
                Bsig2 <= START;
                Bsig3 <= START;
                Bsig4 <= START;
                Bsig5 <= START;
                Bsig6 <= START;
                Bsig7 <= START;
                Bsig8 <= START;
                Bsig9 <= START;
                Bsig10 <= START;
                Bsig11 <= START;
                Bsig12 <= START;
                Bsig13 <= START;
                Bsig14 <= START;
                Bsig15 <= START;
            end  
            else if(INDATA25 == 8'he0) begin
                Asig0 <= STARTg;
            end
            else if(INDATA25 == 8'he1) begin
                Asig1 <= STARTg;
            end
            else if(INDATA25 == 8'he2) begin
                Asig2 <= STARTg;
            end
            else if(INDATA25 == 8'he3) begin
                Asig3 <= STARTg;
            end
            else if(INDATA25 == 8'he4) begin
                Asig4 <= STARTg;
            end
            else if(INDATA25 == 8'he5) begin
                Asig5 <= STARTg;
            end
            else if(INDATA25 == 8'he6) begin
                Asig6 <= STARTg;
            end
            else if(INDATA25 == 8'he7) begin
                Asig7 <= STARTg;
            end
            else if(INDATA25 == 8'he8) begin
                Asig8 <= STARTg;
            end
            else if(INDATA25 == 8'he9) begin
                Asig9 <= STARTg;
            end
            else if(INDATA25 == 8'hea) begin
                Asig10 <= STARTg;
            end
            else if(INDATA25 == 8'heb) begin
                Asig11 <= STARTg;
            end
            else if(INDATA25 == 8'hec) begin
                Asig12 <= STARTg;
            end
            else if(INDATA25 == 8'hed) begin
                Asig13 <= STARTg;
            end
            else if(INDATA25 == 8'hee) begin
                Asig14 <= STARTg;
            end
            else if(INDATA25 == 8'hef) begin
                Asig15 <= STARTg;
            end
            else if(INDATA25 == 8'hf0) begin
                Bsig0 <= STARTg;
            end
            else if(INDATA25 == 8'hf1) begin
                Bsig1 <= STARTg;
            end
            else if(INDATA25 == 8'hf2) begin
                Bsig2 <= STARTg;
            end
            else if(INDATA25 == 8'hf3) begin
                Bsig3 <= STARTg;
            end
            else if(INDATA25 == 8'hf4) begin
                Bsig4 <= STARTg;
            end
            else if(INDATA25 == 8'hf5) begin
                Bsig5 <= STARTg;
            end
            else if(INDATA25 == 8'hf6) begin
                Bsig6 <= STARTg;
            end
            else if(INDATA25 == 8'hf7) begin
                Bsig7 <= STARTg;
            end
            else if(INDATA25 == 8'hf8) begin
                Bsig8 <= STARTg;
            end
            else if(INDATA25 == 8'hf9) begin
                Bsig9 <= STARTg;
            end
            else if(INDATA25 == 8'hfa) begin
                Bsig10 <= STARTg;
            end
            else if(INDATA25 == 8'hfb) begin
                Bsig11 <= STARTg;
            end
            else if(INDATA25 == 8'hfc) begin
                Bsig12 <= STARTg;
            end
            else if(INDATA25 == 8'hfd) begin
                Bsig13 <= STARTg;
            end
            else if(INDATA25 == 8'hfe) begin
                Bsig14 <= STARTg;
            end
            else if(INDATA25 == 8'hff) begin
                Bsig15 <= STARTg;
            end
            
            else  if(INDATA22 == 8'h10) begin
                Asig0 <= START;
            end
            else if(INDATA22 == 8'h11) begin
                Asig1 <= START;
            end
            else if(INDATA22 == 8'h12) begin
                Asig2 <= START;
            end
            else if(INDATA22 == 8'h13) begin
                Asig3 <= START;
            end
            else if(INDATA22 == 8'h14) begin
                Asig4 <= START;
            end
            else if(INDATA22 == 8'h15) begin
                Asig5 <= START;
            end
            else if(INDATA22 == 8'h16) begin
                Asig6 <= START;
            end
            else if(INDATA22 == 8'h17) begin
                Asig7 <= START;
            end
            if(INDATA22 == 8'h18) begin
                Asig8 <= START;
            end
            else if(INDATA22 == 8'h19) begin
                Asig9 <= START;
            end
            else if(INDATA22 == 8'h1a) begin
                Asig10 <= START;
            end
            else if(INDATA22 == 8'h1b) begin
                Asig11 <= START;
            end
            else if(INDATA22 == 8'h1c) begin
                Asig12 <= START;
            end
            else if(INDATA22 == 8'h1d) begin
                Asig13 <= START;
            end
            else if(INDATA22 == 8'h1e) begin
                Asig14 <= START;
            end
            else if(INDATA22 == 8'h1f) begin
                Asig15 <= START;
            end
            
            if(INDATA24 == 8'h10) begin
                Bsig0 <= START;
            end
            else if(INDATA24 == 8'h11) begin
                Bsig1 <= START;
            end
            else if(INDATA24 == 8'h12) begin
                Bsig2 <= START;
            end
            else if(INDATA24 == 8'h13) begin
                Bsig3 <= START;
            end
            else if(INDATA24 == 8'h14) begin
                Bsig4 <= START;
            end
            else if(INDATA24 == 8'h15) begin
                Bsig5 <= START;
            end
            else if(INDATA24 == 8'h16) begin
                Bsig6 <= START;
            end
            else if(INDATA24 == 8'h17) begin
                Bsig7 <= START;
            end
            else if(INDATA24 == 8'h18) begin
                Bsig8 <= START;
            end
            else if(INDATA24 == 8'h19) begin
                Bsig9 <= START;
            end
            else if(INDATA24 == 8'h1a) begin
                Bsig10 <= START;
            end
            else if(INDATA24 == 8'h1b) begin
                Bsig11 <= START;
            end
            else if(INDATA24 == 8'h1c) begin
                Bsig12 <= START;
            end
            else if(INDATA24 == 8'h1d) begin
                Bsig13 <= START;
            end
            else if(INDATA24 == 8'h1e) begin
                Bsig14 <= START;
            end
            else if(INDATA24 == 8'h1f) begin
                Bsig15 <= START;
            end
        end
      end 
      
      
      
      reg [7:0] cont = 8'h00;
      reg [7:0] contA0 = 8'h00;
      reg [7:0] contA1 = 8'h00;
      reg [7:0] contA2 = 8'h00;
      reg [7:0] contA3 = 8'h00;
      reg [7:0] contA4 = 8'h00;
      reg [7:0] contA5 = 8'h00;
      reg [7:0] contA6 = 8'h00;
      reg [7:0] contA7 = 8'h00;
      reg [7:0] contA8 = 8'h00;
      reg [7:0] contA9 = 8'h00;
      reg [7:0] contA10 = 8'h00;
      reg [7:0] contA11 = 8'h00;
      reg [7:0] contA12 = 8'h00;
      reg [7:0] contA13 = 8'h00;
      reg [7:0] contA14 = 8'h00;
      reg [7:0] contA15 = 8'h00;
      reg [7:0] contB0 = 8'h00;
      reg [7:0] contB1 = 8'h00;
      reg [7:0] contB2 = 8'h00;
      reg [7:0] contB3 = 8'h00;
      reg [7:0] contB4 = 8'h00;
      reg [7:0] contB5 = 8'h00;
      reg [7:0] contB6 = 8'h00;
      reg [7:0] contB7 = 8'h00;
      reg [7:0] contB8 = 8'h00;
      reg [7:0] contB9 = 8'h00;
      reg [7:0] contB10 = 8'h00;
      reg [7:0] contB11 = 8'h00;
      reg [7:0] contB12 = 8'h00;
      reg [7:0] contB13 = 8'h00;
      reg [7:0] contB14 = 8'h00;
      reg [7:0] contB15 = 8'h00;
      
      always@(posedge CLK200)begin//signal_cont
              OUTDATA22 <= contA0;
              OUTDATA23 <= contA1;
              OUTDATA24 <= contA2;
              OUTDATA25 <= contA3;
              OUTDATA26 <= contA4;
              OUTDATA27 <= contA5;
              OUTDATA28 <= contA6;
              OUTDATA29 <= contA7;
              OUTDATA2a <= contA8;
              OUTDATA2b <= contA9;
              OUTDATA2c <= contA10;
              OUTDATA2d <= contA11;
              OUTDATA2e <= contA12;
              OUTDATA2f <= contA13;
              OUTDATA30 <= contA14;
              OUTDATA31 <= contA15;
              OUTDATA32 <= contB0;
              OUTDATA33 <= contB1;
              OUTDATA34 <= contB2;
              OUTDATA35 <= contB3;
              OUTDATA36 <= contB4;
              OUTDATA37 <= contB5;
              OUTDATA38 <= contB6;
              OUTDATA39 <= contB7;
              OUTDATA3a <= contB8;
              OUTDATA3b <= contB9;
              OUTDATA3c <= contB10;
              OUTDATA3d <= contB11;
              OUTDATA3e <= contB12;
              OUTDATA3f <= contB13;
              OUTDATA40 <= contB14;
              OUTDATA41 <= contB15;
       //end
       if (INDATA23 ==8'h11) begin
            contA0 <= 8'h00;
            contA1 <= 8'h00;
            contA2 <= 8'h00;
            contA3 <= 8'h00;
            contA4 <= 8'h00;
            contA5 <= 8'h00;
            contA6 <= 8'h00;
            contA7 <= 8'h00;
            contA8 <= 8'h00;
            contA9 <= 8'h00;
            contA10 <= 8'h00;
            contA11 <= 8'h00;
            contA12 <= 8'h00;
            contA13 <= 8'h00;
            contA14 <= 8'h00;
            contA15 <= 8'h00;
            contB0 <= 8'h00;
            contB1 <= 8'h00;
            contB2 <= 8'h00;
            contB3 <= 8'h00;
            contB4 <= 8'h00;
            contB5 <= 8'h00;
            contB6 <= 8'h00;
            contB7 <= 8'h00;
            contB8 <= 8'h00;
            contB9 <= 8'h00;
            contB10 <= 8'h00;
            contB11 <= 8'h00;
            contB12 <= 8'h00;
            contB13 <= 8'h00;
            contB14 <= 8'h00;
            contB15 <= 8'h00;
       end
       else if(INDATA25 ==8'h0f)begin
       if(Ach0 == 1) contA0 <= contA0 + 8'h1;
       if(Ach1 == 1) contA1 <= contA1 + 8'h1;
       if(Ach2 == 1) contA2 <= contA2 + 8'h1;
       if(Ach3 == 1) contA3 <= contA3 + 8'h1;
       if(Ach4 == 1) contA4 <= contA4 + 8'h1;
       if(Ach5 == 1) contA5 <= contA5 + 8'h1;
       if(Ach6 == 1) contA6 <= contA6 + 8'h1;
       if(Ach7 == 1) contA7 <= contA7 + 8'h1;
       if(Ach8 == 1) contA8 <= contA8 + 8'h1;
       if(Ach9 == 1) contA9 <= contA9 + 8'h1;
       if(Ach10 == 1) contA10 <= contA10 + 8'h1;
       if(Ach11 == 1) contA11 <= contA11 + 8'h1;
       if(Ach12 == 1) contA12 <= contA12 + 8'h1;
       if(Ach13 == 1) contA13 <= contA13 + 8'h1;
       if(Ach14 == 1) contA14 <= contA14 + 8'h1;
       if(Ach15 == 1) contA15 <= contA15 + 8'h1;
       if(Bch0 == 1) contB0 <= contB0 + 8'h1;
       if(Bch1 == 1) contB1 <= contB1 + 8'h1;       
       if(Ach2 == 1) contB2 <= contB2 + 8'h1;
       if(Bch3 == 1) contB3 <= contB3 + 8'h1;
       if(Bch4 == 1) contB4 <= contB4 + 8'h1;
       if(Bch5 == 1) contB5 <= contB5 + 8'h1;
       if(Bch6 == 1) contB6 <= contB6 + 8'h1;
       if(Bch7 == 1) contB7 <= contB7 + 8'h1;
       if(Bch8 == 1) contB8 <= contB8 + 8'h1;
       if(Bch9 == 1) contB9 <= contB9 + 8'h1;
       if(Bch10 == 1) contB10 <= contB10 + 8'h1;
       if(Bch11 == 1) contB11 <= contB11 + 8'h1;
       if(Bch12 == 1) contB12 <= contB12 + 8'h1;
       if(Bch13 == 1) contB13 <= contB13 + 8'h1;
       if(Bch14 == 1) contB14 <= contB14 + 8'h1;
       if(Bch15 == 1) contB15 <= contB15 + 8'h1;
       end
       else begin
       if((INDATA22 == 8'h10 ||INDATA25 == 8'he0) && Ach0 == 1) contA0 <= contA0 + 8'h1;
       if((INDATA22 == 8'h11 ||INDATA25 == 8'he1) && Ach1 == 1) contA1 <= contA1 + 8'h1;
       if((INDATA22 == 8'h12 ||INDATA25 == 8'he2) && Ach2 == 1) contA2 <= contA2 + 8'h1;
       if((INDATA22 == 8'h13 ||INDATA25 == 8'he3) && Ach3 == 1) contA3 <= contA3 + 8'h1;
       if((INDATA22 == 8'h14 ||INDATA25 == 8'he4) && Ach4 == 1) contA4 <= contA4 + 8'h1;
       if((INDATA22 == 8'h15 ||INDATA25 == 8'he5) && Ach5 == 1) contA5 <= contA5 + 8'h1;
       if((INDATA22 == 8'h16 ||INDATA25 == 8'he6) && Ach6 == 1) contA6 <= contA6 + 8'h1;
       if((INDATA22 == 8'h17 ||INDATA25 == 8'he7) && Ach7 == 1) contA7 <= contA7 + 8'h1;
       if((INDATA22 == 8'h18 ||INDATA25 == 8'he8) && Ach8 == 1) contA8 <= contA8 + 8'h1;
       if((INDATA22 == 8'h19 ||INDATA25 == 8'he9) && Ach9 == 1) contA9 <= contA9 + 8'h1;
       if((INDATA22 == 8'h1a ||INDATA25 == 8'hea) && Ach10 == 1) contA10 <= contA10 + 8'h1;
       if((INDATA22 == 8'h1b ||INDATA25 == 8'heb) && Ach11 == 1) contA11 <= contA11 + 8'h1;
       if((INDATA22 == 8'h1c ||INDATA25 == 8'hec) && Ach12 == 1) contA12 <= contA12 + 8'h1;
       if((INDATA22 == 8'h1d ||INDATA25 == 8'hed) && Ach13 == 1) contA13 <= contA13 + 8'h1;
       if((INDATA22 == 8'h1e ||INDATA25 == 8'hee) && Ach14 == 1) contA14 <= contA14 + 8'h1;
       if((INDATA22 == 8'h1f ||INDATA25 == 8'hef) && Ach15 == 1) contA15 <= contA15 + 8'h1;
       if((INDATA24 == 8'h10 ||INDATA25 == 8'hf0) && Bch0 == 1) contB0 <= contB0 + 8'h1;
       if((INDATA24 == 8'h11 ||INDATA25 == 8'hf1) && Bch1 == 1) contB1 <= contB1 + 8'h1;       
       if((INDATA24 == 8'h12 ||INDATA25 == 8'hf2) && Bch2 == 1) contB2 <= contB2 + 8'h1;
       if((INDATA24 == 8'h13 ||INDATA25 == 8'hf3) && Bch3 == 1) contB3 <= contB3 + 8'h1;
       if((INDATA24 == 8'h14 ||INDATA25 == 8'hf4) && Bch4 == 1) contB4 <= contB4 + 8'h1;
       if((INDATA24 == 8'h15 ||INDATA25 == 8'hf5) && Bch5 == 1) contB5 <= contB5 + 8'h1;
       if((INDATA24 == 8'h16 ||INDATA25 == 8'hf6) && Bch6 == 1) contB6 <= contB6 + 8'h1;
       if((INDATA24 == 8'h17 ||INDATA25 == 8'hf7) && Bch7 == 1) contB7 <= contB7 + 8'h1;
       if((INDATA24 == 8'h18 ||INDATA25 == 8'hf8) && Bch8 == 1) contB8 <= contB8 + 8'h1;
       if((INDATA24 == 8'h19 ||INDATA25 == 8'hf9) && Bch9 == 1) contB9 <= contB9 + 8'h1;
       if((INDATA24 == 8'h1a ||INDATA25 == 8'hfa) && Bch10 == 1) contB10 <= contB10 + 8'h1;
       if((INDATA24 == 8'h1b ||INDATA25 == 8'hfb) && Bch11 == 1) contB11 <= contB11 + 8'h1;
       if((INDATA24 == 8'h1c ||INDATA25 == 8'hfc) && Bch12 == 1) contB12 <= contB12 + 8'h1;
       if((INDATA24 == 8'h1d ||INDATA25 == 8'hfd) && Bch13 == 1) contB13 <= contB13 + 8'h1;
       if((INDATA24 == 8'h1e ||INDATA25 == 8'hfe) && Bch14 == 1) contB14 <= contB14 + 8'h1;
       if((INDATA24 == 8'h1f ||INDATA25 == 8'hff) && Bch15 == 1) contB15 <= contB15 + 8'h1;
       end
      end
      pp_power pp_power(
          .CLK (CLK40), 
          .sysclk (sysclk),
          .BUFT (BUFT),
          .PP_CLK (PP_CLK),               
          .INDATA4e (INDATA4e),
          .OUTDATA4e (OUTDATA4e),
          .PP33ENb (PP33ENb),
          .PP18ENb (PP18ENb),
          .PP33EN(PP33EN),
          .PP18EN(PP18EN),
          .LED0 (LED0),
          .LED1 (LED1)
                );     
      
endmodule
